Only in jsch-0.1.44: .classpath
diff -urw jsch-0.1.44-clean//examples/ScpTo.java jsch-0.1.44/examples/ScpTo.java
--- jsch-0.1.44-clean//examples/ScpTo.java	2010-02-05 11:30:35.000000000 +0900
+++ jsch-0.1.44/examples/ScpTo.java	2011-04-07 14:55:48.037948000 +0900
@@ -1,17 +1,22 @@
 /* -*-mode:java; c-basic-offset:2; indent-tabs-mode:nil -*- */
 import com.jcraft.jsch.*;
-import java.awt.*;
 import javax.swing.*;
 import java.io.*;
 
 public class ScpTo{
-  public static void main(String[] arg){
+
+	static final String PRIVATE_KEY = "/home/watcharin/.ssh/id_rsa";
+
+	static final String MESSAGE = "Text sent by scp\n";
+
+	static final int PORT = 19000;
+
+	public static void main(String[] arg) throws JSchException {
     if(arg.length!=2){
       System.err.println("usage: java ScpTo file1 user@remotehost:file2");
       System.exit(-1);
     }      
 
-    FileInputStream fis=null;
     try{
 
       String lfile=arg[0];
@@ -21,7 +26,9 @@
       String rfile=arg[1].substring(arg[1].indexOf(':')+1);
 
       JSch jsch=new JSch();
-      Session session=jsch.getSession(user, host, 22);
+			jsch.addIdentity(PRIVATE_KEY);
+
+			Session session = jsch.getSession(user, host, PORT);
 
       // username and password will be given via UserInfo interface.
       UserInfo ui=new MyUserInfo();
@@ -36,68 +43,62 @@
       ((ChannelExec)channel).setCommand(command);
 
       // get I/O streams for remote scp
-      OutputStream out=channel.getOutputStream();
-      InputStream in=channel.getInputStream();
+			OutputStream out = session.getOutputStream();
 
       channel.connect();
+			System.out.printf("[ScpTo : MAIN] Channel connect ..OK\n");
 
-      if(checkAck(in)!=0){
-	System.exit(0);
-      }
-
-      File _lfile = new File(lfile);
+			// File _lfile = new File(lfile);
 
       if(ptimestamp){
-        command="T "+(_lfile.lastModified()/1000)+" 0";
+				long lastMod = 1276004506000L;
+
+				command = "T " + (lastMod / 1000) + " 0";
         // The access time should be sent here,
         // but it is not accessible with JavaAPI ;-<
-        command+=(" "+(_lfile.lastModified()/1000)+" 0\n"); 
-        out.write(command.getBytes()); out.flush();
-        if(checkAck(in)!=0){
-  	  System.exit(0);
-        }
+				command += (" " + (lastMod / 1000) + " 0\n");
       }
 
-      // send "C0644 filesize filename", where filename should not include '/'
-      long filesize=_lfile.length();
+			// send "C0644 filesize filename", where filename should not include
+			// '/'
+			// long filesize=_lfile.length();
+			long filesize = MESSAGE.length();
       command="C0644 "+filesize+" ";
       if(lfile.lastIndexOf('/')>0){
         command+=lfile.substring(lfile.lastIndexOf('/')+1);
-      }
-      else{
+			} else {
         command+=lfile;
       }
       command+="\n";
-      out.write(command.getBytes()); out.flush();
-      if(checkAck(in)!=0){
-	System.exit(0);
-      }
 
       // send a content of lfile
-      fis=new FileInputStream(lfile);
-      byte[] buf=new byte[1024];
-      while(true){
-        int len=fis.read(buf, 0, buf.length);
-	if(len<=0) break;
-        out.write(buf, 0, len); //out.flush();
-      }
-      fis.close();
-      fis=null;
+			// fis=new FileInputStream(lfile);
+			// byte[] buf=new byte[1024];
+			byte[] buf = MESSAGE.getBytes();
+			// while(true){
+			// int len=fis.read(buf, 0, buf.length);
+			// if(len<=0) break;
+			// out.write(buf, 0, len); //out.flush();
+			// }
+			System.out.printf("[MAIN] send a content of lfile\n");
+			out.write(buf, 0, buf.length);
+			out.flush();
+
+			// fis.close();
+			// fis=null;
       // send '\0'
-      buf[0]=0; out.write(buf, 0, 1); out.flush();
-      if(checkAck(in)!=0){
-	System.exit(0);
-      }
+			buf[0] = 0;
+			out.write(buf, 0, 1);
+			out.flush();
       out.close();
 
       channel.disconnect();
       session.disconnect();
 
       System.exit(0);
-    }
-    catch(Exception e){
-      System.out.println(e);
-      try{if(fis!=null)fis.close();}catch(Exception ee){}
+		} catch (IOException e) {
+			e.printStackTrace();
+			// try{if(fis!=null)fis.close();}catch(Exception ee){}
     }
   }
 
@@ -107,8 +108,10 @@
     //          1 for error,
     //          2 for fatal error,
     //          -1
-    if(b==0) return b;
-    if(b==-1) return b;
+		if (b == 0)
+			return b;
+		if (b == -1)
+			return b;
 
     if(b==1 || b==2){
       StringBuffer sb=new StringBuffer();
@@ -116,8 +119,7 @@
       do {
 	c=in.read();
 	sb.append((char)c);
-      }
-      while(c!='\n');
+			} while (c != '\n');
       if(b==1){ // error
 	System.out.print(sb.toString());
       }
@@ -129,93 +131,39 @@
   }
 
   public static class MyUserInfo implements UserInfo, UIKeyboardInteractive{
-    public String getPassword(){ return passwd; }
+		public String getPassword() {
+			return passwd;
+		}
+
     public boolean promptYesNo(String str){
       Object[] options={ "yes", "no" };
-      int foo=JOptionPane.showOptionDialog(null, 
-             str,
-             "Warning", 
-             JOptionPane.DEFAULT_OPTION, 
-             JOptionPane.WARNING_MESSAGE,
+			int foo = JOptionPane.showOptionDialog(null, str, "Warning",
+					JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
              null, options, options[0]);
        return foo==0;
     }
   
     String passwd;
-    JTextField passwordField=(JTextField)new JPasswordField(20);
 
-    public String getPassphrase(){ return null; }
-    public boolean promptPassphrase(String message){ return true; }
-    public boolean promptPassword(String message){
-      Object[] ob={passwordField}; 
-      int result=
-	  JOptionPane.showConfirmDialog(null, ob, message,
-					JOptionPane.OK_CANCEL_OPTION);
-      if(result==JOptionPane.OK_OPTION){
-	passwd=passwordField.getText();
+		public String getPassphrase() {
+			return null;
+		}
+
+		public boolean promptPassphrase(String message) {
 	return true;
       }
-      else{ return false; }
+
+		public boolean promptPassword(String message) {
+			return false;
     }
+
     public void showMessage(String message){
       JOptionPane.showMessageDialog(null, message);
     }
-    final GridBagConstraints gbc = 
-      new GridBagConstraints(0,0,1,1,1,1,
-                             GridBagConstraints.NORTHWEST,
-                             GridBagConstraints.NONE,
-                             new Insets(0,0,0,0),0,0);
-    private Container panel;
+
     public String[] promptKeyboardInteractive(String destination,
-                                              String name,
-                                              String instruction,
-                                              String[] prompt,
-                                              boolean[] echo){
-      panel = new JPanel();
-      panel.setLayout(new GridBagLayout());
-
-      gbc.weightx = 1.0;
-      gbc.gridwidth = GridBagConstraints.REMAINDER;
-      gbc.gridx = 0;
-      panel.add(new JLabel(instruction), gbc);
-      gbc.gridy++;
-
-      gbc.gridwidth = GridBagConstraints.RELATIVE;
-
-      JTextField[] texts=new JTextField[prompt.length];
-      for(int i=0; i<prompt.length; i++){
-        gbc.fill = GridBagConstraints.NONE;
-        gbc.gridx = 0;
-        gbc.weightx = 1;
-        panel.add(new JLabel(prompt[i]),gbc);
-
-        gbc.gridx = 1;
-        gbc.fill = GridBagConstraints.HORIZONTAL;
-        gbc.weighty = 1;
-        if(echo[i]){
-          texts[i]=new JTextField(20);
-        }
-        else{
-          texts[i]=new JPasswordField(20);
-        }
-        panel.add(texts[i], gbc);
-        gbc.gridy++;
-      }
-
-      if(JOptionPane.showConfirmDialog(null, panel, 
-                                       destination+": "+name,
-                                       JOptionPane.OK_CANCEL_OPTION,
-                                       JOptionPane.QUESTION_MESSAGE)
-         ==JOptionPane.OK_OPTION){
-        String[] response=new String[prompt.length];
-        for(int i=0; i<prompt.length; i++){
-          response[i]=texts[i].getText();
-        }
-	return response;
-      }
-      else{
-        return null;  // cancel
-      }
+				String name, String instruction, String[] prompt, boolean[] echo) {
+			return null;
     }
   }
 }
diff -urw jsch-0.1.44-clean//examples/ScpToNoneCipher.java jsch-0.1.44/examples/ScpToNoneCipher.java
--- jsch-0.1.44-clean//examples/ScpToNoneCipher.java	2007-08-29 02:17:44.000000000 +0900
+++ jsch-0.1.44/examples/ScpToNoneCipher.java	2011-03-31 14:02:21.101961999 +0900
@@ -1,6 +1,6 @@
 /* -*-mode:java; c-basic-offset:2; indent-tabs-mode:nil -*- */
 import com.jcraft.jsch.*;
-import java.awt.*;
+
 import javax.swing.*;
 import java.io.*;
 
@@ -11,7 +11,6 @@
       System.exit(-1);
     }      
 
-    FileInputStream fis=null;
     try{
 
       String lfile=arg[0];
@@ -21,7 +20,8 @@
       String rfile=arg[1].substring(arg[1].indexOf(':')+1);
 
       JSch jsch=new JSch();
-      Session session=jsch.getSession(user, host, 22);
+      jsch.addIdentity(ScpTo.PRIVATE_KEY);
+      Session session=jsch.getSession(user, host, ScpTo.PORT);
 
       // username and password will be given via UserInfo interface.
       UserInfo ui=new MyUserInfo();
@@ -49,7 +49,7 @@
       }
 
       // send "C0644 filesize filename", where filename should not include '/'
-      long filesize=(new File(lfile)).length();
+      long filesize=ScpTo.MESSAGE.length();
       command="C0644 "+filesize+" ";
       if(lfile.lastIndexOf('/')>0){
         command+=lfile.substring(lfile.lastIndexOf('/')+1);
@@ -65,15 +65,10 @@
       }
 
       // send a content of lfile
-      fis=new FileInputStream(lfile);
-      byte[] buf=new byte[1024];
-      while(true){
-        int len=fis.read(buf, 0, buf.length);
-	if(len<=0) break;
+      byte[] buf = ScpTo.MESSAGE.getBytes();
+      int len = buf.length;
+      System.out.printf("[MAIN] send a content of a file.\n");
         out.write(buf, 0, len); out.flush();
-      }
-      fis.close();
-      fis=null;
 
       // send '\0'
       buf[0]=0; out.write(buf, 0, 1); out.flush();
@@ -88,7 +83,6 @@
     }
     catch(Exception e){
       System.out.println(e);
-      try{if(fis!=null)fis.close();}catch(Exception ee){}
     }
   }
 
@@ -133,80 +127,22 @@
     }
   
     String passwd;
-    JTextField passwordField=(JTextField)new JPasswordField(20);
 
     public String getPassphrase(){ return null; }
     public boolean promptPassphrase(String message){ return true; }
     public boolean promptPassword(String message){
-      Object[] ob={passwordField}; 
-      int result=
-	  JOptionPane.showConfirmDialog(null, ob, message,
-					JOptionPane.OK_CANCEL_OPTION);
-      if(result==JOptionPane.OK_OPTION){
-	passwd=passwordField.getText();
-	return true;
-      }
-      else{ return false; }
+      return false;
     }
     public void showMessage(String message){
       JOptionPane.showMessageDialog(null, message);
     }
-    final GridBagConstraints gbc = 
-      new GridBagConstraints(0,0,1,1,1,1,
-                             GridBagConstraints.NORTHWEST,
-                             GridBagConstraints.NONE,
-                             new Insets(0,0,0,0),0,0);
-    private Container panel;
+
     public String[] promptKeyboardInteractive(String destination,
                                               String name,
                                               String instruction,
                                               String[] prompt,
                                               boolean[] echo){
-      panel = new JPanel();
-      panel.setLayout(new GridBagLayout());
-
-      gbc.weightx = 1.0;
-      gbc.gridwidth = GridBagConstraints.REMAINDER;
-      gbc.gridx = 0;
-      panel.add(new JLabel(instruction), gbc);
-      gbc.gridy++;
-
-      gbc.gridwidth = GridBagConstraints.RELATIVE;
-
-      JTextField[] texts=new JTextField[prompt.length];
-      for(int i=0; i<prompt.length; i++){
-        gbc.fill = GridBagConstraints.NONE;
-        gbc.gridx = 0;
-        gbc.weightx = 1;
-        panel.add(new JLabel(prompt[i]),gbc);
-
-        gbc.gridx = 1;
-        gbc.fill = GridBagConstraints.HORIZONTAL;
-        gbc.weighty = 1;
-        if(echo[i]){
-          texts[i]=new JTextField(20);
-        }
-        else{
-          texts[i]=new JPasswordField(20);
-        }
-        panel.add(texts[i], gbc);
-        gbc.gridy++;
-      }
-
-      if(JOptionPane.showConfirmDialog(null, panel, 
-                                       destination+": "+name,
-                                       JOptionPane.OK_CANCEL_OPTION,
-                                       JOptionPane.QUESTION_MESSAGE)
-         ==JOptionPane.OK_OPTION){
-        String[] response=new String[prompt.length];
-        for(int i=0; i<prompt.length; i++){
-          response[i]=texts[i].getText();
-        }
-	return response;
-      }
-      else{
-        return null;  // cancel
-      }
+    	return null;
     }
   }
 }
Only in jsch-0.1.44: keys.bin
Only in jsch-0.1.44: .project
diff -urw jsch-0.1.44-clean//src/com/jcraft/jsch/ChannelExec.java jsch-0.1.44/src/com/jcraft/jsch/ChannelExec.java
--- jsch-0.1.44-clean//src/com/jcraft/jsch/ChannelExec.java	2010-03-05 16:59:21.000000000 +0900
+++ jsch-0.1.44/src/com/jcraft/jsch/ChannelExec.java	2011-04-07 14:56:40.041948001 +0900
@@ -37,17 +37,18 @@
 
   public void start() throws JSchException{
     Session _session=getSession();
-    try{
-      sendRequests();
-      Request request=new RequestExec(command);
-      request.request(_session, this);
-    }
-    catch(Exception e){
-      if(e instanceof JSchException) throw (JSchException)e;
-      if(e instanceof Throwable)
-        throw new JSchException("ChannelExec", (Throwable)e);
-      throw new JSchException("ChannelExec");
-    }
+
+//		try {
+//			sendRequests();
+//			Request request = new RequestExec(command);
+//			request.request(_session, this);
+//		} catch (Exception e) {
+//			if (e instanceof JSchException)
+//				throw (JSchException) e;
+//			if (e instanceof Throwable)
+//				throw new JSchException("ChannelExec", (Throwable) e);
+//			throw new JSchException("ChannelExec");
+//		}
 
     if(io.in!=null){
       thread=new Thread(this);
@@ -55,13 +56,16 @@
       if(_session.daemon_thread){
         thread.setDaemon(_session.daemon_thread);
       }
+
       thread.start();
     }
+		System.out.printf("[ChannelExec : start] End\n");
   }
 
   public void setCommand(String command){ 
     this.command=Util.str2byte(command);
   }
+
   public void setCommand(byte[] command){ 
     this.command=command;
   }
@@ -74,9 +78,11 @@
   public void setErrStream(java.io.OutputStream out){
     setExtOutputStream(out);
   }
+
   public void setErrStream(java.io.OutputStream out, boolean dontclose){
     setExtOutputStream(out, dontclose);
   }
+
   public java.io.InputStream getErrStream() throws java.io.IOException {
     return getExtInputStream();
   }
diff -urw jsch-0.1.44-clean//src/com/jcraft/jsch/Channel.java jsch-0.1.44/src/com/jcraft/jsch/Channel.java
--- jsch-0.1.44-clean//src/com/jcraft/jsch/Channel.java	2010-10-26 17:06:59.000000000 +0900
+++ jsch-0.1.44/src/com/jcraft/jsch/Channel.java	2011-04-07 15:19:59.973948000 +0900
@@ -35,7 +35,6 @@
 import java.io.OutputStream;
 import java.io.IOException;
 
-
 public abstract class Channel implements Runnable{
 
   static final int SSH_MSG_CHANNEL_OPEN_CONFIRMATION=      91;
@@ -49,6 +48,7 @@
 
   static int index=0; 
   private static java.util.Vector pool=new java.util.Vector();
+
   static Channel getChannel(String type){
     if(type.equals("session")){
       return new ChannelSession();
@@ -79,15 +79,18 @@
     }
     return null;
   }
+
   static Channel getChannel(int id, Session session){
     synchronized(pool){
       for(int i=0; i<pool.size(); i++){
         Channel c=(Channel)(pool.elementAt(i));
-        if(c.id==id && c.session==session) return c;
+				if (c.id == id && c.session == session)
+					return c;
       }
     }
     return null;
   }
+
   static void del(Channel c){
     synchronized(pool){
       pool.removeElement(c);
@@ -130,10 +133,12 @@
       pool.addElement(this);
     }
   }
+
   void setRecipient(int foo){
     this.recipient=foo;
   }
-  int getRecipient(){
+
+	public int getRecipient() {
     return recipient;
   }
 
@@ -153,32 +158,41 @@
     try{
       Buffer buf=new Buffer(100);
       Packet packet=new Packet(buf);
-      // send
-      // byte   SSH_MSG_CHANNEL_OPEN(90)
-      // string channel type         //
-      // uint32 sender channel       // 0
-      // uint32 initial window size  // 0x100000(65536)
-      // uint32 maxmum packet size   // 0x4000(16384)
+
       packet.reset();
-      buf.putByte((byte)90);
-      buf.putString(this.type);
-      buf.putInt(this.id);
-      buf.putInt(this.lwsize);
-      buf.putInt(this.lmpsize);
+			// Send immediate key.
       _session.write(packet);
+			// Receive immediate key.
+			_session.read(buf, 4);
+
+			// -- [Begin] Fix synchronization bug --
+			// Wait until field "recipient" is set before going on.
+			synchronized (_session) {
+				while (getRecipient() < 0) {
+					try {
+						_session.wait();
+					} catch (InterruptedException e) {
+						e.printStackTrace();
+					}
+				}
+			}
+			// -- [End] Fix synchronization bug --
+
       int retry=1000;
       long start=System.currentTimeMillis();
       long timeout=connectTimeout;
-      while(this.getRecipient()==-1 &&
-	    _session.isConnected() &&
-	    retry>0){
+			while (this.getRecipient() == -1 && _session.isConnected()
+					&& retry > 0) {
         if(timeout>0L){
           if((System.currentTimeMillis()-start)>timeout){
             retry=0;
             continue;
           }
         }
-	try{Thread.sleep(50);}catch(Exception ee){}
+				try {
+					Thread.sleep(50);
+				} catch (Exception ee) {
+				}
 	retry--;
       }
       if(!_session.isConnected()){
@@ -198,8 +212,7 @@
       }
       connected=true;
       start();
-    }
-    catch(Exception e){
+		} catch (Exception e) {
       connected=false;
       disconnect();
       if(e instanceof JSchException) 
@@ -211,9 +224,12 @@
   public void setXForwarding(boolean foo){
   }
 
-  public void start() throws JSchException{}
+	public void start() throws JSchException {
+	}
 
-  public boolean isEOF() {return eof_remote;}
+	public boolean isEOF() {
+		return eof_remote;
+	}
 
   void getData(Buffer buf){
     setRecipient(buf.getInt());
@@ -224,44 +240,49 @@
   public void setInputStream(InputStream in){
     io.setInputStream(in, false);
   }
+
   public void setInputStream(InputStream in, boolean dontclose){
     io.setInputStream(in, dontclose);
   }
+
   public void setOutputStream(OutputStream out){
     io.setOutputStream(out, false);
   }
+
   public void setOutputStream(OutputStream out, boolean dontclose){
     io.setOutputStream(out, dontclose);
   }
+
   public void setExtOutputStream(OutputStream out){
     io.setExtOutputStream(out, false);
   }
+
   public void setExtOutputStream(OutputStream out, boolean dontclose){
     io.setExtOutputStream(out, dontclose);
   }
+
   public InputStream getInputStream() throws IOException {
-    PipedInputStream in=
-      new MyPipedInputStream(
-                             32*1024  // this value should be customizable.
+		PipedInputStream in = new MyPipedInputStream(32 * 1024 // this value
+																// should be
+																// customizable.
                              );
     io.setOutputStream(new PassiveOutputStream(in), false);
     return in;
   }
+
   public InputStream getExtInputStream() throws IOException {
-    PipedInputStream in=
-      new MyPipedInputStream(
-                             32*1024  // this value should be customizable.
+		PipedInputStream in = new MyPipedInputStream(32 * 1024 // this value
+																// should be
+																// customizable.
                              );
     io.setExtOutputStream(new PassiveOutputStream(in), false);
     return in;
   }
+
   public OutputStream getOutputStream() throws IOException {
     /*
-    PipedOutputStream out=new PipedOutputStream();
-    io.setInputStream(new PassiveInputStream(out
-                                             , 32*1024
-                                             ), false);
-    return out;
+		 * PipedOutputStream out=new PipedOutputStream(); io.setInputStream(new
+		 * PassiveInputStream(out , 32*1024 ), false); return out;
     */
 
     final Channel channel=this;
@@ -270,6 +291,7 @@
         private Buffer buffer=null;
         private Packet packet=null;
         private boolean closed=false;
+
         private synchronized void init() throws java.io.IOException{
           buffer=new Buffer(rmpsize);
           packet=new Packet(buffer);
@@ -282,12 +304,16 @@
           }
 
         }
+
         byte[] b=new byte[1];
+
         public void write(int w) throws java.io.IOException{
           b[0]=(byte)w;
           write(b, 0, 1);
         }
-        public void write(byte[] buf, int s, int l) throws java.io.IOException{
+
+			public void write(byte[] buf, int s, int l)
+					throws java.io.IOException {
           if(packet==null){
             init();
           }
@@ -331,19 +357,18 @@
             int foo=dataLen;
             dataLen=0;
             getSession().write(packet, channel, foo);
-          }
-          catch(Exception e){
+				} catch (Exception e) {
             close();
             throw new java.io.IOException(e.toString());
           }
 
         }
+
         public void close() throws java.io.IOException{
           if(packet==null){
             try{
               init();
-            }
-            catch(java.io.IOException e){
+					} catch (java.io.IOException e) {
               // close should be finished silently.
               return;
             }
@@ -362,27 +387,50 @@
   }
 
   class MyPipedInputStream extends PipedInputStream{
-    MyPipedInputStream() throws IOException{ super(); }
+		MyPipedInputStream() throws IOException {
+			super();
+		}
+
     MyPipedInputStream(int size) throws IOException{
       super();
       buffer=new byte[size];
     }
-    MyPipedInputStream(PipedOutputStream out) throws IOException{ super(out); }
+
+		MyPipedInputStream(PipedOutputStream out) throws IOException {
+			super(out);
+		}
+
     MyPipedInputStream(PipedOutputStream out, int size) throws IOException{
       super(out);
       buffer=new byte[size];
     }
   }
-  void setLocalWindowSizeMax(int foo){ this.lwsize_max=foo; }
-  void setLocalWindowSize(int foo){ this.lwsize=foo; }
-  void setLocalPacketSize(int foo){ this.lmpsize=foo; }
-  synchronized void setRemoteWindowSize(long foo){ this.rwsize=foo; }
+
+	void setLocalWindowSizeMax(int foo) {
+		this.lwsize_max = foo;
+	}
+
+	void setLocalWindowSize(int foo) {
+		this.lwsize = foo;
+	}
+
+	void setLocalPacketSize(int foo) {
+		this.lmpsize = foo;
+	}
+
+	synchronized void setRemoteWindowSize(long foo) {
+		this.rwsize = foo;
+	}
+
   synchronized void addRemoteWindowSize(int foo){ 
     this.rwsize+=foo; 
     if(notifyme>0)
       notifyAll();
   }
-  void setRemotePacketSize(int foo){ this.rmpsize=foo; }
+
+	void setRemotePacketSize(int foo) {
+		this.rmpsize = foo;
+	}
 
   public void run(){
   }
@@ -390,27 +438,32 @@
   void write(byte[] foo) throws IOException {
     write(foo, 0, foo.length);
   }
+
   void write(byte[] foo, int s, int l) throws IOException {
     try{
       io.put(foo, s, l);
-    }catch(NullPointerException e){}
+		} catch (NullPointerException e) {
   }
+	}
+
   void write_ext(byte[] foo, int s, int l) throws IOException {
     try{
       io.put_ext(foo, s, l);
-    }catch(NullPointerException e){}
+		} catch (NullPointerException e) {
+		}
   }
 
   void eof_remote(){
     eof_remote=true;
     try{
       io.out_close();
+		} catch (NullPointerException e) {
     }
-    catch(NullPointerException e){}
   }
 
   void eof(){
-    if(eof_local)return;
+		if (eof_local)
+			return;
     eof_local=true;
 
     try{
@@ -423,54 +476,49 @@
         if(!close)
           getSession().write(packet);
       }
-    }
-    catch(Exception e){
+		} catch (Exception e) {
       //System.err.println("Channel.eof");
       //e.printStackTrace();
     }
     /*
-    if(!isConnected()){ disconnect(); }
+		 * if(!isConnected()){ disconnect(); }
     */
   }
 
   /*
-  http://www1.ietf.org/internet-drafts/draft-ietf-secsh-connect-24.txt
-
-5.3  Closing a Channel
-  When a party will no longer send more data to a channel, it SHOULD
-   send SSH_MSG_CHANNEL_EOF.
-
-            byte      SSH_MSG_CHANNEL_EOF
-            uint32    recipient_channel
-
-  No explicit response is sent to this message.  However, the
-   application may send EOF to whatever is at the other end of the
-  channel.  Note that the channel remains open after this message, and
-   more data may still be sent in the other direction.  This message
-   does not consume window space and can be sent even if no window space
-   is available.
-
-     When either party wishes to terminate the channel, it sends
-     SSH_MSG_CHANNEL_CLOSE.  Upon receiving this message, a party MUST
-   send back a SSH_MSG_CHANNEL_CLOSE unless it has already sent this
-   message for the channel.  The channel is considered closed for a
-     party when it has both sent and received SSH_MSG_CHANNEL_CLOSE, and
-   the party may then reuse the channel number.  A party MAY send
-   SSH_MSG_CHANNEL_CLOSE without having sent or received
-   SSH_MSG_CHANNEL_EOF.
-
-            byte      SSH_MSG_CHANNEL_CLOSE
-            uint32    recipient_channel
-
-   This message does not consume window space and can be sent even if no
-   window space is available.
-
-   It is recommended that any data sent before this message is delivered
-     to the actual destination, if possible.
+	 * http://www1.ietf.org/internet-drafts/draft-ietf-secsh-connect-24.txt
+	 * 
+	 * 5.3 Closing a Channel When a party will no longer send more data to a
+	 * channel, it SHOULD send SSH_MSG_CHANNEL_EOF.
+	 * 
+	 * byte SSH_MSG_CHANNEL_EOF uint32 recipient_channel
+	 * 
+	 * No explicit response is sent to this message. However, the application
+	 * may send EOF to whatever is at the other end of the channel. Note that
+	 * the channel remains open after this message, and more data may still be
+	 * sent in the other direction. This message does not consume window space
+	 * and can be sent even if no window space is available.
+	 * 
+	 * When either party wishes to terminate the channel, it sends
+	 * SSH_MSG_CHANNEL_CLOSE. Upon receiving this message, a party MUST send
+	 * back a SSH_MSG_CHANNEL_CLOSE unless it has already sent this message for
+	 * the channel. The channel is considered closed for a party when it has
+	 * both sent and received SSH_MSG_CHANNEL_CLOSE, and the party may then
+	 * reuse the channel number. A party MAY send SSH_MSG_CHANNEL_CLOSE without
+	 * having sent or received SSH_MSG_CHANNEL_EOF.
+	 * 
+	 * byte SSH_MSG_CHANNEL_CLOSE uint32 recipient_channel
+	 * 
+	 * This message does not consume window space and can be sent even if no
+	 * window space is available.
+	 * 
+	 * It is recommended that any data sent before this message is delivered to
+	 * the actual destination, if possible.
   */
 
   void close(){
-    if(close)return;
+		if (close)
+			return;
     close=true;
     eof_local=eof_remote=true;
 
@@ -483,14 +531,15 @@
       synchronized(this){
         getSession().write(packet);
       }
-    }
-    catch(Exception e){
+		} catch (Exception e) {
       //e.printStackTrace();
     }
   }
+
   public boolean isClosed(){
     return close;
   }
+
   static void disconnect(Session session){
     Channel[] channels=null;
     int count=0;
@@ -502,8 +551,7 @@
 	  if(c.session==session){
 	    channels[count++]=c;
 	  }
-	}
-	catch(Exception e){
+				} catch (Exception e) {
 	}
       } 
     }
@@ -535,13 +583,11 @@
         if(io!=null){
           io.close();
         }
-      }
-      catch(Exception e){
+			} catch (Exception e) {
         //e.printStackTrace();
       }
       // io=null;
-    }
-    finally{
+		} finally {
       Channel.del(this);
     }
   }
@@ -561,27 +607,28 @@
   }
 
 //  public String toString(){
-//      return "Channel: type="+new String(type)+",id="+id+",recipient="+recipient+",window_size="+window_size+",packet_size="+packet_size;
+	// return "Channel: type="+new
+	// String(type)+",id="+id+",recipient="+recipient+",window_size="+window_size+",packet_size="+packet_size;
 //  }
 
 /*
-  class OutputThread extends Thread{
-    Channel c;
-    OutputThread(Channel c){ this.c=c;}
-    public void run(){c.output_thread();}
-  }
+	 * class OutputThread extends Thread{ Channel c; OutputThread(Channel c){
+	 * this.c=c;} public void run(){c.output_thread();} }
 */
 
   class PassiveInputStream extends MyPipedInputStream{
     PipedOutputStream out;
+
     PassiveInputStream(PipedOutputStream out, int size) throws IOException{
       super(out, size);
       this.out=out;
     }
+
     PassiveInputStream(PipedOutputStream out) throws IOException{
       super(out);
       this.out=out;
     }
+
     public void close() throws IOException{
       if(out!=null){
         this.out.close();
@@ -589,14 +636,20 @@
       out=null;
     }
   }
+
   class PassiveOutputStream extends PipedOutputStream{
     PassiveOutputStream(PipedInputStream in) throws IOException{
       super(in);
     }
   }
 
-  void setExitStatus(int status){ exitstatus=status; }
-  public int getExitStatus(){ return exitstatus; }
+	void setExitStatus(int status) {
+		exitstatus = status;
+	}
+
+	public int getExitStatus() {
+		return exitstatus;
+	}
 
   void setSession(Session session){
     this.session=session;
@@ -609,7 +662,10 @@
     }
     return _session;
   }
-  public int getId(){ return id; }
+
+	public int getId() {
+		return id;
+	}
 
   protected void sendOpenConfirmation() throws Exception{
     Buffer buf=new Buffer(100);
@@ -634,8 +690,7 @@
       buf.putString(Util.str2byte("open failed"));
       buf.putString(Util.empty);
       getSession().write(packet);
-    }
-    catch(Exception e){
+		} catch (Exception e) {
     }
   }
 }
diff -urw jsch-0.1.44-clean//src/com/jcraft/jsch/ChannelSession.java jsch-0.1.44/src/com/jcraft/jsch/ChannelSession.java
--- jsch-0.1.44-clean//src/com/jcraft/jsch/ChannelSession.java	2010-03-05 16:59:32.000000000 +0900
+++ jsch-0.1.44/src/com/jcraft/jsch/ChannelSession.java	2011-04-07 14:29:19.597948000 +0900
@@ -73,7 +73,8 @@
   }
 
   /**
-   * @deprecated Use {@link #setEnv(String, String)} or {@link #setEnv(byte[], byte[])} instead.
+	 * @deprecated Use {@link #setEnv(String, String)} or
+	 *             {@link #setEnv(byte[], byte[])} instead.
    * @see #setEnv(String, String)
    * @see #setEnv(byte[], byte[])
    */
@@ -84,13 +85,14 @@
   }
 
   /**
-   * Set the environment variable. 
-   * If <code>name</code> and <code>value</code> are needed to be passed 
-   * to the remote in your faivorite encoding,use 
+	 * Set the environment variable. If <code>name</code> and <code>value</code>
+	 * are needed to be passed to the remote in your faivorite encoding,use
    * {@link #setEnv(byte[], byte[])}.
    *
-   * @param name A name for environment variable.
-   * @param value A value for environment variable.
+	 * @param name
+	 *            A name for environment variable.
+	 * @param value
+	 *            A value for environment variable.
    * @see RFC4254 6.4 Environment Variable Passing
    */
   public void setEnv(String name, String value){
@@ -100,8 +102,10 @@
   /**
    * Set the environment variable.
    *
-   * @param name A name of environment variable.
-   * @param value A value of environment variable.
+	 * @param name
+	 *            A name of environment variable.
+	 * @param value
+	 *            A value of environment variable.
    * @see #setEnv(String, String)
    * @see RFC4254 6.4 Environment Variable Passing
    */
@@ -139,10 +143,14 @@
   /**
    * Change the window dimension interactively.
    * 
-   * @param col terminal width, columns
-   * @param row terminal height, rows
-   * @param wp terminal width, pixels
-   * @param hp terminal height, pixels
+	 * @param col
+	 *            terminal width, columns
+	 * @param row
+	 *            terminal height, rows
+	 * @param wp
+	 *            terminal width, pixels
+	 * @param hp
+	 *            terminal height, pixels
    * @see RFC4254 6.7. Window Dimension Change Message
    */
   public void setPtySize(int col, int row, int wp, int hp){
@@ -154,17 +162,17 @@
       RequestWindowChange request=new RequestWindowChange();
       request.setSize(col, row, wp, hp);
       request.request(getSession(), this);
-    }
-    catch(Exception e){
+		} catch (Exception e) {
       //System.err.println("ChannelSessio.setPtySize: "+e);
     }
   }
 
   /**
-   * Set the terminal type.
-   * This method is not effective after Channel#connect().
+	 * Set the terminal type. This method is not effective after
+	 * Channel#connect().
    *
-   * @param ttype terminal type(for example, "vt100")
+	 * @param ttype
+	 *            terminal type(for example, "vt100")
    * @see #setPtyType(String, int, int, int, int)
    */
   public void setPtyType(String ttype){
@@ -172,14 +180,19 @@
   }
 
   /**
-   * Set the terminal type.
-   * This method is not effective after Channel#connect().
+	 * Set the terminal type. This method is not effective after
+	 * Channel#connect().
    *
-   * @param ttype terminal type(for example, "vt100")
-   * @param col terminal width, columns
-   * @param row terminal height, rows
-   * @param wp terminal width, pixels
-   * @param hp terminal height, pixels
+	 * @param ttype
+	 *            terminal type(for example, "vt100")
+	 * @param col
+	 *            terminal width, columns
+	 * @param row
+	 *            terminal height, rows
+	 * @param wp
+	 *            terminal width, pixels
+	 * @param hp
+	 *            terminal height, pixels
    */
   public void setPtyType(String ttype, int col, int row, int wp, int hp){
     this.ttype=ttype;
@@ -237,38 +250,38 @@
     Buffer buf=new Buffer(rmpsize);
     Packet packet=new Packet(buf);
     int i=-1;
-    try{
-      while(isConnected() &&
-	    thread!=null && 
-            io!=null && 
-            io.in!=null){
-        i=io.in.read(buf.buffer, 
-                     14,    
-                     buf.buffer.length-14
-                     -32 -20 // padding and mac
-		     );
-	if(i==0)continue;
-	if(i==-1){
-	  eof();
-	  break;
-	}
-	if(close)break;
-        //System.out.println("write: "+i);
-        packet.reset();
-        buf.putByte((byte)Session.SSH_MSG_CHANNEL_DATA);
-        buf.putInt(recipient);
-        buf.putInt(i);
-        buf.skip(i);
-	getSession().write(packet, this, i);
-      }
-    }
-    catch(Exception e){
-      //System.err.println("# ChannelExec.run");
-      //e.printStackTrace();
-    }
+//		try {
+//			while (isConnected() && thread != null && io != null
+//					&& io.in != null) {
+//				i = io.in.read(buf.buffer, 14, buf.buffer.length - 14 - 32 - 20 // padding
+//																				// and
+//																				// mac
+//						);
+//				if (i == 0)
+//					continue;
+//				if (i == -1) {
+//					eof();
+//					break;
+//				}
+//				if (close)
+//					break;
+//				// System.out.println("write: "+i);
+//				packet.reset();
+//				buf.putByte((byte) Session.SSH_MSG_CHANNEL_DATA);
+//				buf.putInt(recipient);
+//				buf.putInt(i);
+//				buf.skip(i);
+//				getSession().write(packet, this, i);
+//			}
+//		} catch (Exception e) {
+//			// System.err.println("# ChannelExec.run");
+//			// e.printStackTrace();
+//		}
     Thread _thread=thread; 
     if(_thread!=null){
-      synchronized(_thread){ _thread.notifyAll(); }
+			synchronized (_thread) {
+				_thread.notifyAll();
+			}
     }
     thread=null;
     //System.err.println(this+":run <");
diff -urw jsch-0.1.44-clean//src/com/jcraft/jsch/Packet.java jsch-0.1.44/src/com/jcraft/jsch/Packet.java
--- jsch-0.1.44-clean//src/com/jcraft/jsch/Packet.java	2010-03-05 17:02:38.000000000 +0900
+++ jsch-0.1.44/src/com/jcraft/jsch/Packet.java	2011-04-07 14:15:54.517948000 +0900
@@ -40,7 +40,7 @@
     this.buffer=buffer;
   }
   public void reset(){
-    buffer.index=5;
+    buffer.index=4;
   }
   void padding(int bsize){
     int len=buffer.index;
diff -urw jsch-0.1.44-clean//src/com/jcraft/jsch/Session.java jsch-0.1.44/src/com/jcraft/jsch/Session.java
--- jsch-0.1.44-clean//src/com/jcraft/jsch/Session.java	2010-10-26 17:09:12.000000000 +0900
+++ jsch-0.1.44/src/com/jcraft/jsch/Session.java	2011-04-07 14:55:34.341948000 +0900
@@ -29,8 +29,13 @@
 
 package com.jcraft.jsch;
 
+import gov.nasa.jpf.jvm.Verify;
+
 import java.io.*;
 import java.net.*;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
 
 public class Session implements Runnable{
   static private final String version="JSCH-0.1.44";
@@ -164,8 +169,7 @@
       try{
 	Class c=Class.forName(getConfig("random"));
         random=(Random)(c.newInstance());
-      }
-      catch(Exception e){ 
+			} catch (Exception e) {
         throw new JSchException(e.toString(), e);
       }
     }
@@ -186,8 +190,7 @@
           socket=Util.createSocket(host, port, connectTimeout);
 	  in=socket.getInputStream();
 	  out=socket.getOutputStream();
-	}
-	else{
+				} else {
           socket=socket_factory.createSocket(host, port);
 	  in=socket_factory.getInputStream(socket);
 	  out=socket_factory.getOutputStream(socket);
@@ -196,8 +199,7 @@
         socket.setTcpNoDelay(true);
         io.setInputStream(in);
         io.setOutputStream(out);
-      }
-      else{
+			} else {
 	synchronized(proxy){
           proxy.connect(socket_factory, host, port, connectTimeout);
 	  io.setInputStream(proxy.getInputStream());
@@ -212,60 +214,27 @@
 
       isConnected=true;
 
-      if(JSch.getLogger().isEnabled(Logger.INFO)){
-        JSch.getLogger().log(Logger.INFO, 
-                             "Connection established");
-      }
+			// if (JSch.getLogger().isEnabled(Logger.INFO)) {
+			// JSch.getLogger().log(Logger.INFO, "Connection established");
+			// }
 
       jsch.addSession(this);
 
       {
-	// Some Cisco devices will miss to read '\n' if it is sent separately.
+				// Some Cisco devices will miss to read '\n' if it is sent
+				// separately.
 	byte[] foo=new byte[V_C.length+1];
 	System.arraycopy(V_C, 0, foo, 0, V_C.length);
 	foo[foo.length-1]=(byte)'\n';
 	io.put(foo, 0, foo.length);
       }
 
-      while(true){
-        i=0;
-        j=0;
-        while(i<buf.buffer.length){
+			for (i = 0; i < 8; i++) {
           j=io.getByte();
-          if(j<0)break;
-          buf.buffer[i]=(byte)j; i++; 
-          if(j==10)break;
-        }
-        if(j<0){
-          throw new JSchException("connection is closed by foreign host");
-        }
-
-        if(buf.buffer[i-1]==10){    // 0x0a
-          i--;
-          if(i>0 && buf.buffer[i-1]==13){  // 0x0d
-            i--;
-          }
         }
 
-        if(i<=3 || 
-           ((i!=buf.buffer.length) &&
-            (buf.buffer[0]!='S'||buf.buffer[1]!='S'||
-             buf.buffer[2]!='H'||buf.buffer[3]!='-'))){
-          // It must not start with 'SSH-'
-          //System.err.println(new String(buf.buffer, 0, i);
-          continue;
-        }
-
-        if(i==buf.buffer.length ||
-           i<7 ||                                      // SSH-1.99 or SSH-2.0
-           (buf.buffer[4]=='1' && buf.buffer[6]!='9')  // SSH-1.5
-           ){
-          throw new JSchException("invalid server's version string");
-        }
-        break;
-      }
-
-      V_S=new byte[i]; System.arraycopy(buf.buffer, 0, V_S, 0, i);
+			V_S = new byte[i];
+			System.arraycopy(buf.buffer, 0, V_S, 0, i);
       //System.err.println("V_S: ("+i+") ["+new String(V_S)+"]");
 
       if(JSch.getLogger().isEnabled(Logger.INFO)){
@@ -275,186 +244,9 @@
                              "Local version string: "+Util.byte2str(V_C));
       }
 
-      send_kexinit();
-
-      buf=read(buf);
-      if(buf.getCommand()!=SSH_MSG_KEXINIT){
-        in_kex=false;
-	throw new JSchException("invalid protocol: "+buf.getCommand());
-      }
-
-      if(JSch.getLogger().isEnabled(Logger.INFO)){
-        JSch.getLogger().log(Logger.INFO, 
-                             "SSH_MSG_KEXINIT received");
-      }
-
-      KeyExchange kex=receive_kexinit(buf);
-
-      while(true){
-	buf=read(buf);
-	if(kex.getState()==buf.getCommand()){
-          kex_start_time=System.currentTimeMillis();
-          boolean result=kex.next(buf);
-	  if(!result){
-	    //System.err.println("verify: "+result);
-            in_kex=false;
-	    throw new JSchException("verify: "+result);
-	  }
-	}
-	else{
-          in_kex=false;
-	  throw new JSchException("invalid protocol(kex): "+buf.getCommand());
-	}
-	if(kex.getState()==KeyExchange.STATE_END){
-	  break;
-	}
-      }
-
-      try{ checkHost(host, port, kex); }
-      catch(JSchException ee){
-        in_kex=false;
-        throw ee;
-      }
-
-      send_newkeys();
-
-      // receive SSH_MSG_NEWKEYS(21)
-      buf=read(buf);
-      //System.err.println("read: 21 ? "+buf.getCommand());
-      if(buf.getCommand()==SSH_MSG_NEWKEYS){
-
-        if(JSch.getLogger().isEnabled(Logger.INFO)){
-          JSch.getLogger().log(Logger.INFO, 
-                               "SSH_MSG_NEWKEYS received");
-        }
-
-	receive_newkeys(buf, kex);
-      }
-      else{
-        in_kex=false;
-	throw new JSchException("invalid protocol(newkyes): "+buf.getCommand());
-      }
-
-      boolean auth=false;
+			boolean auth = true;
       boolean auth_cancel=false;
 
-      UserAuth ua=null;
-      try{
-	Class c=Class.forName(getConfig("userauth.none"));
-        ua=(UserAuth)(c.newInstance());
-      }
-      catch(Exception e){ 
-        throw new JSchException(e.toString(), e);
-      }
-
-      auth=ua.start(this);
-
-      String cmethods=getConfig("PreferredAuthentications");
-      String[] cmethoda=Util.split(cmethods, ",");
-
-      String smethods=null;
-      if(!auth){
-        smethods=((UserAuthNone)ua).getMethods();
-        if(smethods!=null){
-          smethods=smethods.toLowerCase();
-        }
-        else{
-          // methods: publickey,password,keyboard-interactive
-          //smethods="publickey,password,keyboard-interactive";
-          smethods=cmethods;
-        }
-      }
-
-      String[] smethoda=Util.split(smethods, ",");
-
-      int methodi=0;
-
-      loop:
-      while(true){
-
-//System.err.println("methods: "+methods);
-
-	while(!auth && 
-	      cmethoda!=null && methodi<cmethoda.length){
-
-          String method=cmethoda[methodi++];
-          boolean acceptable=false;
-          for(int k=0; k<smethoda.length; k++){
-            if(smethoda[k].equals(method)){
-              acceptable=true;
-              break;
-            }
-          }
-          if(!acceptable){
-            continue;
-          }
-
-          //System.err.println("  method: "+method);
-
-          if(JSch.getLogger().isEnabled(Logger.INFO)){
-            String str="Authentications that can continue: ";
-            for(int k=methodi-1; k<cmethoda.length; k++){
-              str+=cmethoda[k];
-              if(k+1<cmethoda.length)
-                str+=",";
-            }
-            JSch.getLogger().log(Logger.INFO, 
-                                 str);
-            JSch.getLogger().log(Logger.INFO, 
-                                 "Next authentication method: "+method);
-          }
-
-	  ua=null;
-          try{
-            Class c=null;
-            if(getConfig("userauth."+method)!=null){
-              c=Class.forName(getConfig("userauth."+method));
-              ua=(UserAuth)(c.newInstance());
-            }
-          }
-          catch(Exception e){
-            if(JSch.getLogger().isEnabled(Logger.WARN)){
-              JSch.getLogger().log(Logger.WARN, 
-                                   "failed to load "+method+" method");
-            }
-          }
-
-	  if(ua!=null){
-            auth_cancel=false;
-	    try{ 
-	      auth=ua.start(this); 
-              if(auth && 
-                 JSch.getLogger().isEnabled(Logger.INFO)){
-                JSch.getLogger().log(Logger.INFO, 
-                                     "Authentication succeeded ("+method+").");
-              }
-	    }
-	    catch(JSchAuthCancelException ee){
-	      auth_cancel=true;
-	    }
-	    catch(JSchPartialAuthException ee){
-              String tmp = smethods;
-              smethods=ee.getMethods();
-              smethoda=Util.split(smethods, ",");
-              if(!tmp.equals(smethods)){
-                methodi=0;
-              }
-	      //System.err.println("PartialAuth: "+methods);
-	      auth_cancel=false;
-	      continue loop;
-	    }
-	    catch(RuntimeException ee){
-	      throw ee;
-	    }
-	    catch(Exception ee){
-	      //System.err.println("ee: "+ee); // SSH_MSG_DISCONNECT: 2 Too many authentication failures
-              break loop;
-	    }
-	  }
-	}
-        break;
-      }
-
       if(!auth){
         if(auth_cancel)
           throw new JSchException("Auth cancel");
@@ -470,19 +262,18 @@
       synchronized(lock){
         if(isConnected){
           connectThread=new Thread(this);
-          connectThread.setName("Connect thread "+host+" session");
+					connectThread
+							.setName("Connect thread " + host + " session");
           if(daemon_thread){
             connectThread.setDaemon(daemon_thread);
           }
           connectThread.start();
-        }
-        else{
+				} else {
           // The session has been already down and
           // we don't have to start new thread.
         }
       }
-    }
-    catch(Exception e) {
+		} catch (Exception e) {
       in_kex=false;
       if(isConnected){
 	try{
@@ -493,17 +284,17 @@
 	  buf.putString(Util.str2byte("en"));
 	  write(packet);
 	  disconnect();
-	}
-	catch(Exception ee){
+				} catch (Exception ee) {
 	}
       }
       isConnected=false;
-      //e.printStackTrace();
-      if(e instanceof RuntimeException) throw (RuntimeException)e;
-      if(e instanceof JSchException) throw (JSchException)e;
+			e.printStackTrace();
+			if (e instanceof RuntimeException)
+				throw (RuntimeException) e;
+			if (e instanceof JSchException)
+				throw (JSchException) e;
       throw new JSchException("Session.connect: "+e);
-    }
-    finally{
+		} finally {
       Util.bzero(this.password);
       this.password=null;
     }
@@ -514,8 +305,7 @@
     if(j!=buf.getLength()){    // packet was compressed and
       buf.getByte();           // j is the size of deflated packet.
       I_S=new byte[buf.index-5];
-    }
-    else{
+		} else {
       I_S=new byte[j-1-buf.getByte()];
     }
    System.arraycopy(buf.buffer, buf.s, I_S, 0, I_S.length);
@@ -529,29 +319,33 @@
       throw new JSchException("Algorithm negotiation fail");
     }
 
-    if(!isAuthed &&
-       (guess[KeyExchange.PROPOSAL_ENC_ALGS_CTOS].equals("none") ||
-        (guess[KeyExchange.PROPOSAL_ENC_ALGS_STOC].equals("none")))){
-      throw new JSchException("NONE Cipher should not be chosen before authentification is successed.");
+		if (!isAuthed
+				&& (guess[KeyExchange.PROPOSAL_ENC_ALGS_CTOS].equals("none") || (guess[KeyExchange.PROPOSAL_ENC_ALGS_STOC]
+						.equals("none")))) {
+			throw new JSchException(
+					"NONE Cipher should not be chosen before authentification is successed.");
     }
 
     KeyExchange kex=null;
     try{
-      Class c=Class.forName(getConfig(guess[KeyExchange.PROPOSAL_KEX_ALGS]));
+			Class c = Class
+					.forName(getConfig(guess[KeyExchange.PROPOSAL_KEX_ALGS]));
       kex=(KeyExchange)(c.newInstance());
-    }
-    catch(Exception e){ 
+		} catch (Exception e) {
       throw new JSchException(e.toString(), e);
     }
 
     kex.init(this, V_S, V_C, I_S, I_C);
+
     return kex;
   }
 
   private boolean in_kex=false;
+
   public void rekey() throws Exception {
     send_kexinit();
   }
+
   private void send_kexinit() throws Exception {
     if(in_kex)
       return;
@@ -559,7 +353,8 @@
     String cipherc2s=getConfig("cipher.c2s");
     String ciphers2c=getConfig("cipher.s2c");
 
-    String[] not_available=checkCiphers(getConfig("CheckCiphers"));
+		// String[] not_available=checkCiphers(getConfig("CheckCiphers"));
+		String[] not_available = new String[0];
     if(not_available!=null && not_available.length>0){
       cipherc2s=Util.diffString(cipherc2s, not_available);
       ciphers2c=Util.diffString(ciphers2c, not_available);
@@ -588,7 +383,8 @@
     packet.reset();
     buf.putByte((byte) SSH_MSG_KEXINIT);
     synchronized(random){
-      random.fill(buf.buffer, buf.index, 16); buf.skip(16);
+			random.fill(buf.buffer, buf.index, 16);
+			buf.skip(16);
     }
     buf.putString(Util.str2byte(getConfig("kex")));
     buf.putString(Util.str2byte(getConfig("server_host_key")));
@@ -610,8 +406,7 @@
     write(packet);
 
     if(JSch.getLogger().isEnabled(Logger.INFO)){
-      JSch.getLogger().log(Logger.INFO, 
-                           "SSH_MSG_KEXINIT sent");
+			JSch.getLogger().log(Logger.INFO, "SSH_MSG_KEXINIT sent");
     }
   }
 
@@ -622,12 +417,12 @@
     write(packet);
 
     if(JSch.getLogger().isEnabled(Logger.INFO)){
-      JSch.getLogger().log(Logger.INFO, 
-                           "SSH_MSG_NEWKEYS sent");
+			JSch.getLogger().log(Logger.INFO, "SSH_MSG_NEWKEYS sent");
     }
   }
 
-  private void checkHost(String chost, int port, KeyExchange kex) throws JSchException {
+	private void checkHost(String chost, int port, KeyExchange kex)
+			throws JSchException {
     String shkc=getConfig("StrictHostKeyChecking");
 
     if(hostKeyAlias!=null){
@@ -654,32 +449,40 @@
 
     boolean insert=false;
 
-    if((shkc.equals("ask") || shkc.equals("yes")) &&
-       i==HostKeyRepository.CHANGED){
+		if ((shkc.equals("ask") || shkc.equals("yes"))
+				&& i == HostKeyRepository.CHANGED) {
       String file=null;
       synchronized(hkr){
 	file=hkr.getKnownHostsRepositoryID();
       }
-      if(file==null){file="known_hosts";}
+			if (file == null) {
+				file = "known_hosts";
+			}
 
       boolean b=false;
 
       if(userinfo!=null){
-        String message=
-"WARNING: REMOTE HOST IDENTIFICATION HAS CHANGED!\n"+
-"IT IS POSSIBLE THAT SOMEONE IS DOING SOMETHING NASTY!\n"+
-"Someone could be eavesdropping on you right now (man-in-the-middle attack)!\n"+
-"It is also possible that the "+key_type+" host key has just been changed.\n"+
-"The fingerprint for the "+key_type+" key sent by the remote host is\n"+
-key_fprint+".\n"+
-"Please contact your system administrator.\n"+
-"Add correct host key in "+file+" to get rid of this message.";
+				String message = "WARNING: REMOTE HOST IDENTIFICATION HAS CHANGED!\n"
+						+ "IT IS POSSIBLE THAT SOMEONE IS DOING SOMETHING NASTY!\n"
+						+ "Someone could be eavesdropping on you right now (man-in-the-middle attack)!\n"
+						+ "It is also possible that the "
+						+ key_type
+						+ " host key has just been changed.\n"
+						+ "The fingerprint for the "
+						+ key_type
+						+ " key sent by the remote host is\n"
+						+ key_fprint
+						+ ".\n"
+						+ "Please contact your system administrator.\n"
+						+ "Add correct host key in "
+						+ file
+						+ " to get rid of this message.";
 
         if(shkc.equals("ask")){
-          b=userinfo.promptYesNo(message+
-                                 "\nDo you want to delete the old key and insert the new key?");
-        }
-        else{  // shkc.equals("yes")
+					b = userinfo
+							.promptYesNo(message
+									+ "\nDo you want to delete the old key and insert the new key?");
+				} else { // shkc.equals("yes")
           userinfo.showMessage(message);
         }
       }
@@ -689,60 +492,56 @@
       }
 
       synchronized(hkr){
-        hkr.remove(chost, 
-                   (key_type.equals("DSA") ? "ssh-dss" : "ssh-rsa"), 
-                   null);
+				hkr.remove(chost, (key_type.equals("DSA") ? "ssh-dss"
+						: "ssh-rsa"), null);
         insert=true;
       }
     }
 
-    if((shkc.equals("ask") || shkc.equals("yes")) &&
-       (i!=HostKeyRepository.OK) && !insert){
+		if ((shkc.equals("ask") || shkc.equals("yes"))
+				&& (i != HostKeyRepository.OK) && !insert) {
       if(shkc.equals("yes")){
 	throw new JSchException("reject HostKey: "+host);
       }
       //System.err.println("finger-print: "+key_fprint);
       if(userinfo!=null){
-	boolean foo=userinfo.promptYesNo(
-"The authenticity of host '"+host+"' can't be established.\n"+
-key_type+" key fingerprint is "+key_fprint+".\n"+
-"Are you sure you want to continue connecting?"
-					 );
+				boolean foo = true;
 	if(!foo){
 	  throw new JSchException("reject HostKey: "+host);
 	}
 	insert=true;
-      }
-      else{
+			} else {
 	if(i==HostKeyRepository.NOT_INCLUDED) 
-	  throw new JSchException("UnknownHostKey: "+host+". "+key_type+" key fingerprint is "+key_fprint);
+					throw new JSchException("UnknownHostKey: " + host + ". "
+							+ key_type + " key fingerprint is " + key_fprint);
 	else 
           throw new JSchException("HostKey has been changed: "+host);
       }
     }
 
-    if(shkc.equals("no") && 
-       HostKeyRepository.NOT_INCLUDED==i){
+		if (shkc.equals("no") && HostKeyRepository.NOT_INCLUDED == i) {
       insert=true;
     }
 
-    if(i==HostKeyRepository.OK &&
-       JSch.getLogger().isEnabled(Logger.INFO)){
-      JSch.getLogger().log(Logger.INFO, 
-                           "Host '"+host+"' is known and mathces the "+key_type+" host key");
+		if (i == HostKeyRepository.OK
+				&& JSch.getLogger().isEnabled(Logger.INFO)) {
+			JSch.getLogger().log(
+					Logger.INFO,
+					"Host '" + host + "' is known and mathces the " + key_type
+							+ " host key");
     }
 
-    if(insert &&
-       JSch.getLogger().isEnabled(Logger.WARN)){
-      JSch.getLogger().log(Logger.WARN, 
-                           "Permanently added '"+host+"' ("+key_type+") to the list of known hosts.");
+		if (insert && JSch.getLogger().isEnabled(Logger.WARN)) {
+			JSch.getLogger().log(
+					Logger.WARN,
+					"Permanently added '" + host + "' (" + key_type
+							+ ") to the list of known hosts.");
     }
 
     String hkh=getConfig("HashKnownHosts");
     if(hkh.equals("yes") && (hkr instanceof KnownHosts)){
       hostkey=((KnownHosts)hkr).createHashedHostKey(chost, K_S);
-    }
-    else{
+		} else {
       hostkey=new HostKey(chost, K_S);
     }
 
@@ -766,13 +565,60 @@
       addChannel(channel);
       channel.init();
       return channel;
-    }
-    catch(Exception e){
+		} catch (Exception e) {
       //e.printStackTrace();
     }
     return null;
   }
 
+	public static void saveList(String file, List<byte[]> list) {
+		try {
+			ObjectOutputStream os = new ObjectOutputStream(
+					new FileOutputStream(file));
+
+			os.writeObject(list);
+			os.close();
+		} catch (FileNotFoundException e) {
+			e.printStackTrace();
+		} catch (IOException e) {
+			e.printStackTrace();
+		}
+	}
+
+	@SuppressWarnings("unchecked")
+	public static List<byte[]> loadList(String file) {
+		try {
+			ObjectInputStream is = new ObjectInputStream(new FileInputStream(
+					file));
+
+			List<byte[]> rt = (List<byte[]>) is.readObject();
+			is.close();
+
+			return rt;
+		} catch (FileNotFoundException e) {
+			return new ArrayList<byte[]>();
+		} catch (IOException e) {
+			e.printStackTrace();
+		} catch (ClassNotFoundException e) {
+			e.printStackTrace();
+		}
+
+		return null;
+	}
+
+	public int listIndex(byte[] k) {
+		for (int i = 0; i < keys.size(); i++) {
+			if (Arrays.equals(keys.get(i), k))
+				return i;
+		}
+
+		return -1;
+	}
+
+	private List<byte[]> keys;
+
+	private List<byte[]> values;
+
   // encode will bin invoked in write with synchronization.
   public void encode(Packet packet) throws Exception{
 //System.err.println("encode: "+packet.buffer.getCommand());
@@ -780,40 +626,89 @@
 //if(packet.buffer.getCommand()==96){
 //Thread.dumpStack();
 //}
+		// byte[] arg = Arrays.copyOfRange(packet.buffer.buffer, 0,
+		// packet.buffer.index);
+		// byte[] answer = null;
+		//
+		// System.out.printf("[Session : encode] Load lists\n");
+		// keys = loadList("keys.bin");
+		// values = loadList("values.bin");
+		// System.out.printf("[Session : encode] Load lists OK\n");
+		// int idx = listIndex(arg);
+		//
+		// // Cache hit
+		// if (idx != -1) {
+		// System.out.printf("[Session : encode] Cache hit\n");
+		// answer = values.get(idx);
+		// } else {
+		// keys.add(arg);
+		// }
+
     if(deflater!=null){
-      packet.buffer.index=deflater.compress(packet.buffer.buffer, 
-					    5, packet.buffer.index);
+			packet.buffer.index = deflater.compress(packet.buffer.buffer, 5,
+					packet.buffer.index);
     }
+
+		System.out.println("[Session : encode] c2scipher: " + c2scipher);
     if(c2scipher!=null){
       //packet.padding(c2scipher.getIVSize());
       packet.padding(c2scipher_size);
       int pad=packet.buffer.buffer[4];
       synchronized(random){
-	random.fill(packet.buffer.buffer, packet.buffer.index-pad, pad);
-      }
+				random.fill(packet.buffer.buffer, packet.buffer.index - pad,
+						pad);
     }
-    else{
+		} else {
       packet.padding(8);
     }
 
+		System.out.println("[Session : encode] c2smac: " + c2smac);
     if(c2smac!=null){
       c2smac.update(seqo);
       c2smac.update(packet.buffer.buffer, 0, packet.buffer.index);
       c2smac.doFinal(packet.buffer.buffer, packet.buffer.index);
     }
+
     if(c2scipher!=null){
       byte[] buf=packet.buffer.buffer;
       c2scipher.update(buf, 0, packet.buffer.index, buf, 0);
     }
+
     if(c2smac!=null){
       packet.buffer.skip(c2smac.getBlockSize());
     }
+
+		// Post processing
+		// if (idx != -1) {
+		// System.arraycopy(answer, 0, packet.buffer.buffer, 0, answer.length);
+		// packet.buffer.index = answer.length;
+		// }
+		// else {
+		// byte[] v = Arrays.copyOfRange(packet.buffer.buffer, 0,
+		// packet.buffer.index);
+		//
+		// values.add(v);
+		//
+		// System.out.printf("[Session : encode] Save lists\n");
+		// // Save the lists in files.
+		// saveList("keys.bin", keys);
+		// saveList("values.bin", values);
+		// System.out.printf("[Session : encode] Save lists OK\n");
+		// }
   }
 
   int[] uncompress_len=new int[1];
 
   private int s2ccipher_size=8;
   private int c2scipher_size=8;
+
+	public Buffer read(Buffer buf, int len) throws IOException {
+		io.getByte(buf.buffer, buf.index, len);
+		buf.rewind();
+		
+		return buf;
+	}
+	
   public Buffer read(Buffer buf) throws Exception{
     int j=0;
     while(true){
@@ -823,10 +718,10 @@
       if(s2ccipher!=null){
         s2ccipher.update(buf.buffer, 0, s2ccipher_size, buf.buffer, 0);
       }
-      j=((buf.buffer[0]<<24)&0xff000000)|
-        ((buf.buffer[1]<<16)&0x00ff0000)|
-        ((buf.buffer[2]<< 8)&0x0000ff00)|
-        ((buf.buffer[3]    )&0x000000ff);
+			j = ((buf.buffer[0] << 24) & 0xff000000)
+					| ((buf.buffer[1] << 16) & 0x00ff0000)
+					| ((buf.buffer[2] << 8) & 0x0000ff00)
+					| ((buf.buffer[3]) & 0x000000ff);
       // RFC 4253 6.1. Maximum Packet Length
       if(j<5 || j>PACKET_MAX_SIZE){
         start_discard(buf, s2ccipher, s2cmac, j, PACKET_MAX_SIZE);
@@ -846,13 +741,16 @@
         if(JSch.getLogger().isEnabled(Logger.FATAL)){
           JSch.getLogger().log(Logger.FATAL, message); 
         }
-        start_discard(buf, s2ccipher, s2cmac, j, PACKET_MAX_SIZE-s2ccipher_size);
+				start_discard(buf, s2ccipher, s2cmac, j, PACKET_MAX_SIZE
+						- s2ccipher_size);
       }
 
       if(need>0){
-	io.getByte(buf.buffer, buf.index, need); buf.index+=(need);
+				io.getByte(buf.buffer, buf.index, need);
+				buf.index += (need);
 	if(s2ccipher!=null){
-	  s2ccipher.update(buf.buffer, s2ccipher_size, need, buf.buffer, s2ccipher_size);
+					s2ccipher.update(buf.buffer, s2ccipher_size, need,
+							buf.buffer, s2ccipher_size);
 	}
       }
 
@@ -866,7 +764,8 @@
           if(need > PACKET_MAX_SIZE){
             throw new IOException("MAC Error");
           }
-          start_discard(buf, s2ccipher, s2cmac, j, PACKET_MAX_SIZE-need);
+					start_discard(buf, s2ccipher, s2cmac, j, PACKET_MAX_SIZE
+							- need);
           continue;
 	}
       }
@@ -881,8 +780,7 @@
 	if(foo!=null){
 	  buf.buffer=foo;
 	  buf.index=5+uncompress_len[0];
-	}
-	else{
+				} else {
 	  System.err.println("fail in inflater");
 	  break;
 	}
@@ -892,50 +790,45 @@
       //System.err.println("read: "+type);
       if(type==SSH_MSG_DISCONNECT){
         buf.rewind();
-        buf.getInt();buf.getShort();
+				buf.getInt();
+				buf.getShort();
 	int reason_code=buf.getInt();
 	byte[] description=buf.getString();
 	byte[] language_tag=buf.getString();
-	throw new JSchException("SSH_MSG_DISCONNECT: "+
-				    reason_code+
-				" "+Util.byte2str(description)+
-				" "+Util.byte2str(language_tag));
+				throw new JSchException("SSH_MSG_DISCONNECT: " + reason_code
+						+ " " + Util.byte2str(description) + " "
+						+ Util.byte2str(language_tag));
 	//break;
-      }
-      else if(type==SSH_MSG_IGNORE){
-      }
-      else if(type==SSH_MSG_UNIMPLEMENTED){
+			} else if (type == SSH_MSG_IGNORE) {
+			} else if (type == SSH_MSG_UNIMPLEMENTED) {
         buf.rewind();
-        buf.getInt();buf.getShort();
+				buf.getInt();
+				buf.getShort();
 	int reason_id=buf.getInt();
         if(JSch.getLogger().isEnabled(Logger.INFO)){
           JSch.getLogger().log(Logger.INFO, 
                                "Received SSH_MSG_UNIMPLEMENTED for "+reason_id);
         }
-      }
-      else if(type==SSH_MSG_DEBUG){
+			} else if (type == SSH_MSG_DEBUG) {
         buf.rewind();
-        buf.getInt();buf.getShort();
+				buf.getInt();
+				buf.getShort();
 /*
-	byte always_display=(byte)buf.getByte();
-	byte[] message=buf.getString();
-	byte[] language_tag=buf.getString();
-	System.err.println("SSH_MSG_DEBUG:"+
-			   " "+Util.byte2str(message)+
-			   " "+Util.byte2str(language_tag));
+				 * byte always_display=(byte)buf.getByte(); byte[]
+				 * message=buf.getString(); byte[] language_tag=buf.getString();
+				 * System.err.println("SSH_MSG_DEBUG:"+
+				 * " "+Util.byte2str(message)+ " "+Util.byte2str(language_tag));
 */
-      }
-      else if(type==SSH_MSG_CHANNEL_WINDOW_ADJUST){
+			} else if (type == SSH_MSG_CHANNEL_WINDOW_ADJUST) {
           buf.rewind();
-          buf.getInt();buf.getShort();
+				buf.getInt();
+				buf.getShort();
 	  Channel c=Channel.getChannel(buf.getInt(), this);
 	  if(c==null){
-	  }
-	  else{
+				} else {
 	    c.addRemoteWindowSize(buf.getInt()); 
 	  }
-      }
-      else if(type==UserAuth.SSH_MSG_USERAUTH_SUCCESS){
+			} else if (type == UserAuth.SSH_MSG_USERAUTH_SUCCESS) {
         isAuthed=true;
         if(inflater==null && deflater==null){
           String method;
@@ -946,8 +839,7 @@
           initInflater(method);
         }
         break;
-      }
-      else{
+			} else {
         break;
       }
     }
@@ -994,6 +886,7 @@
     updateKeys(kex);
     in_kex=false;
   }
+
   private void updateKeys(KeyExchange kex) throws Exception{
     byte[] K=kex.getK();
     byte[] H=kex.getH();
@@ -1007,12 +900,12 @@
     }
 
     /*
-      Initial IV client to server:     HASH (K || H || "A" || session_id)
-      Initial IV server to client:     HASH (K || H || "B" || session_id)
-      Encryption key client to server: HASH (K || H || "C" || session_id)
-      Encryption key server to client: HASH (K || H || "D" || session_id)
-      Integrity key client to server:  HASH (K || H || "E" || session_id)
-      Integrity key server to client:  HASH (K || H || "F" || session_id)
+		 * Initial IV client to server: HASH (K || H || "A" || session_id)
+		 * Initial IV server to client: HASH (K || H || "B" || session_id)
+		 * Encryption key client to server: HASH (K || H || "C" || session_id)
+		 * Encryption key server to client: HASH (K || H || "D" || session_id)
+		 * Integrity key client to server: HASH (K || H || "E" || session_id)
+		 * Integrity key server to client: HASH (K || H || "F" || session_id)
     */
 
     buf.reset();
@@ -1103,8 +996,7 @@
 
       method=guess[KeyExchange.PROPOSAL_COMP_ALGS_STOC];
       initInflater(method);
-    }
-    catch(Exception e){ 
+		} catch (Exception e) {
       if(e instanceof JSchException)
         throw e;
       throw new JSchException(e.toString(), e);
@@ -1112,15 +1004,20 @@
     }
   }
 
-  /*public*/ /*synchronized*/ void write(Packet packet, Channel c, int length) throws Exception{
+	/* public *//* synchronized */void write(Packet packet, Channel c,
+			int length) throws Exception {
     long t = getTimeout();
     while(true){
       if(in_kex){
         if(t>0L && (System.currentTimeMillis()-kex_start_time)>t){
-          throw new JSchException("timeout in wating for rekeying process.");
+					throw new JSchException(
+							"timeout in wating for rekeying process.");
+				}
+				try {
+					Thread.sleep(10);
+				} catch (java.lang.InterruptedException e) {
         }
-        try{Thread.sleep(10);}
-        catch(java.lang.InterruptedException e){};
+				;
         continue;
       }
       synchronized(c){
@@ -1144,7 +1041,8 @@
             len=length;
           }
           if(len!=length){
-            s=packet.shift((int)len, (c2smac!=null ? c2smac.getBlockSize() : 0));
+						s = packet.shift((int) len,
+								(c2smac != null ? c2smac.getBlockSize() : 0));
           }
 	  command=packet.buffer.getCommand();
 	  recipient=c.getRecipient();
@@ -1172,10 +1070,8 @@
         try{ 
           c.notifyme++;
           c.wait(100); 
-        }
-        catch(java.lang.InterruptedException e){
-        }
-        finally{
+				} catch (java.lang.InterruptedException e) {
+				} finally {
           c.notifyme--;
         }
       }
@@ -1189,353 +1085,104 @@
     long t = getTimeout();
     while(in_kex){
       if(t>0L && (System.currentTimeMillis()-kex_start_time)>t){
-        throw new JSchException("timeout in wating for rekeying process.");
+				throw new JSchException(
+						"timeout in wating for rekeying process.");
       }
       byte command=packet.buffer.getCommand();
-      //System.err.println("command: "+command);
-      if(command==SSH_MSG_KEXINIT ||
-         command==SSH_MSG_NEWKEYS ||
-         command==SSH_MSG_KEXDH_INIT ||
-         command==SSH_MSG_KEXDH_REPLY ||
-         command==SSH_MSG_KEX_DH_GEX_GROUP ||
-         command==SSH_MSG_KEX_DH_GEX_INIT ||
-         command==SSH_MSG_KEX_DH_GEX_REPLY ||
-         command==SSH_MSG_KEX_DH_GEX_REQUEST ||
-         command==SSH_MSG_DISCONNECT){
-        break;
-      }
-      try{Thread.sleep(10);}
-      catch(java.lang.InterruptedException e){};
-    }
-    _write(packet);
-  }
 
-  private void _write(Packet packet) throws Exception{
-    synchronized(lock){
-      encode(packet);
-      if(io!=null){
-        io.put(packet);
-        seqo++;
-      }
-    }
+			if (command == SSH_MSG_KEXINIT || command == SSH_MSG_NEWKEYS
+					|| command == SSH_MSG_KEXDH_INIT
+					|| command == SSH_MSG_KEXDH_REPLY
+					|| command == SSH_MSG_KEX_DH_GEX_GROUP
+					|| command == SSH_MSG_KEX_DH_GEX_INIT
+					|| command == SSH_MSG_KEX_DH_GEX_REPLY
+					|| command == SSH_MSG_KEX_DH_GEX_REQUEST
+					|| command == SSH_MSG_DISCONNECT) {
+				break;
   }
-
-  Runnable thread;
-  public void run(){
-    thread=this;
-
-    byte[] foo;
-    Buffer buf=new Buffer();
-    Packet packet=new Packet(buf);
-    int i=0;
-    Channel channel;
-    int[] start=new int[1];
-    int[] length=new int[1];
-    KeyExchange kex=null;
-
-    int stimeout=0;
-    try{
-      while(isConnected &&
-	    thread!=null){
         try{
-          buf=read(buf);
-          stimeout=0;
+				Thread.sleep(10);
+			} catch (java.lang.InterruptedException e) {
         }
-        catch(InterruptedIOException/*SocketTimeoutException*/ ee){
-          if(!in_kex && stimeout<serverAliveCountMax){
-            sendKeepAliveMsg();
-            stimeout++;
-            continue;
+			;
           }
-          else if(in_kex && stimeout<serverAliveCountMax){
-            stimeout++;
-            continue;
+		_write(packet);
           }
-          throw ee;
+
+	public static String hex(byte[] d) {
+		return hex(d, 0, d.length);
         }
 
-	int msgType=buf.getCommand()&0xff;
+	public static String hex(byte[] d, int off, int len) {
+		StringBuffer hexString = new StringBuffer();
 
-	if(kex!=null && kex.getState()==msgType){
-          kex_start_time=System.currentTimeMillis();
-	  boolean result=kex.next(buf);
-	  if(!result){
-	    throw new JSchException("verify: "+result);
+		for (int i = 0; i < len; i++) {
+			String hex = Integer.toHexString(0xFF & d[off + i]);
+			if (hex.length() == 1) {
+				// could use a for loop, but we're only dealing with a single
+				// byte
+				hexString.append('0');
 	  }
-	  continue;
+			hexString.append(hex + " ");
 	}
 
-        switch(msgType){
-	case SSH_MSG_KEXINIT:
-//System.err.println("KEXINIT");
-	  kex=receive_kexinit(buf);
-	  break;
-
-	case SSH_MSG_NEWKEYS:
-//System.err.println("NEWKEYS");
-          send_newkeys();
-	  receive_newkeys(buf, kex);
-	  kex=null;
-	  break;
-
-	case SSH_MSG_CHANNEL_DATA:
-          buf.getInt(); 
-          buf.getByte(); 
-          buf.getByte(); 
-          i=buf.getInt(); 
-	  channel=Channel.getChannel(i, this);
-	  foo=buf.getString(start, length);
-	  if(channel==null){
-	    break;
+		return hexString.toString();
 	  }
 
-          if(length[0]==0){
-	    break;
-          }
+	private void _write(Packet packet) throws Exception {
+		synchronized (lock) {
+			Buffer b = packet.getBuffer();
+			if (b.index < 100)
+				System.out.printf("[Session : _write] (%d) %s\n", b.index,
+						hex(b.buffer, 0, b.index));
 
-try{
-	  channel.write(foo, start[0], length[0]);
+//			encode(packet);
+			if (io != null) {
+				io.put(packet);
+				seqo++;
 }
-catch(Exception e){
-//System.err.println(e);
-  try{channel.disconnect();}catch(Exception ee){}
-break;
 }
-	  int len=length[0];
-	  channel.setLocalWindowSize(channel.lwsize-len);
- 	  if(channel.lwsize<channel.lwsize_max/2){
-            packet.reset();
-	    buf.putByte((byte)SSH_MSG_CHANNEL_WINDOW_ADJUST);
-	    buf.putInt(channel.getRecipient());
-	    buf.putInt(channel.lwsize_max-channel.lwsize);
-	    write(packet);
-	    channel.setLocalWindowSize(channel.lwsize_max);
 	  }
-	  break;
 
-        case SSH_MSG_CHANNEL_EXTENDED_DATA:
-          buf.getInt();
-	  buf.getShort();
-	  i=buf.getInt();
-	  channel=Channel.getChannel(i, this);
-	  buf.getInt();                   // data_type_code == 1
-	  foo=buf.getString(start, length);
-	  //System.err.println("stderr: "+new String(foo,start[0],length[0]));
-	  if(channel==null){
-	    break;
-	  }
-
-          if(length[0]==0){
-	    break;
-          }
+	Runnable thread;
 
-	  channel.write_ext(foo, start[0], length[0]);
+	public void run() {
+		System.out.printf("[Session : run] Begin\n");
+		thread = this;
 
-	  len=length[0];
-	  channel.setLocalWindowSize(channel.lwsize-len);
- 	  if(channel.lwsize<channel.lwsize_max/2){
-            packet.reset();
-	    buf.putByte((byte)SSH_MSG_CHANNEL_WINDOW_ADJUST);
-	    buf.putInt(channel.getRecipient());
-	    buf.putInt(channel.lwsize_max-channel.lwsize);
-	    write(packet);
-	    channel.setLocalWindowSize(channel.lwsize_max);
-	  }
-	  break;
+		Channel channel;
 
-	case SSH_MSG_CHANNEL_WINDOW_ADJUST:
-          buf.getInt(); 
-	  buf.getShort(); 
-	  i=buf.getInt(); 
-	  channel=Channel.getChannel(i, this);
-	  if(channel==null){
-	    break;
-	  }
-	  channel.addRemoteWindowSize(buf.getInt()); 
-	  break;
+		try {
+			while (isConnected && thread != null) {
+				channel = Channel.getChannel(0, this);
 
-	case SSH_MSG_CHANNEL_EOF:
-          buf.getInt(); 
-          buf.getShort(); 
-          i=buf.getInt(); 
-	  channel=Channel.getChannel(i, this);
-	  if(channel!=null){
-	    //channel.eof_remote=true;
-	    //channel.eof();
-	    channel.eof_remote();
-	  }
-	  /*
-	  packet.reset();
-	  buf.putByte((byte)SSH_MSG_CHANNEL_EOF);
-	  buf.putInt(channel.getRecipient());
-	  write(packet);
-	  */
-	  break;
-	case SSH_MSG_CHANNEL_CLOSE:
-          buf.getInt(); 
-	  buf.getShort(); 
-	  i=buf.getInt(); 
-	  channel=Channel.getChannel(i, this);
 	  if(channel!=null){
-//	      channel.close();
-	    channel.disconnect();
-	  }
-	  /*
-          if(Channel.pool.size()==0){
-	    thread=null;
-	  }
-	  */
-	  break;
-	case SSH_MSG_CHANNEL_OPEN_CONFIRMATION:
-          buf.getInt(); 
-	  buf.getShort(); 
-	  i=buf.getInt(); 
-	  channel=Channel.getChannel(i, this);
-	  if(channel==null){
-	    //break;
-	  }
-          int r=buf.getInt();
-          long rws=buf.getUInt();
-          int rps=buf.getInt();
-
-          channel.setRemoteWindowSize(rws);
-          channel.setRemotePacketSize(rps);
-          channel.setRecipient(r);
-          break;
-	case SSH_MSG_CHANNEL_OPEN_FAILURE:
-          buf.getInt(); 
-	  buf.getShort(); 
-	  i=buf.getInt(); 
-	  channel=Channel.getChannel(i, this);
-	  if(channel==null){
-	    //break;
-	  }
-	  int reason_code=buf.getInt(); 
-	  //foo=buf.getString();  // additional textual information
-	  //foo=buf.getString();  // language tag 
-	  channel.exitstatus=reason_code;
-	  channel.close=true;
-	  channel.eof_remote=true;
-	  channel.setRecipient(0);
-	  break;
-	case SSH_MSG_CHANNEL_REQUEST:
-          buf.getInt(); 
-	  buf.getShort(); 
-	  i=buf.getInt(); 
-	  foo=buf.getString(); 
-          boolean reply=(buf.getByte()!=0);
-	  channel=Channel.getChannel(i, this);
-	  if(channel!=null){
-	    byte reply_type=(byte)SSH_MSG_CHANNEL_FAILURE;
-	    if((Util.byte2str(foo)).equals("exit-status")){
-	      i=buf.getInt();             // exit-status
-	      channel.setExitStatus(i);
-	      reply_type=(byte)SSH_MSG_CHANNEL_SUCCESS;
-	    }
-	    if(reply){
-	      packet.reset();
-	      buf.putByte(reply_type);
-	      buf.putInt(channel.getRecipient());
-	      write(packet);
-	    }
-	  }
-	  else{
-	  }
-	  break;
-	case SSH_MSG_CHANNEL_OPEN:
-          buf.getInt(); 
-	  buf.getShort(); 
-	  foo=buf.getString(); 
-	  String ctyp=Util.byte2str(foo);
-          if(!"forwarded-tcpip".equals(ctyp) &&
-	     !("x11".equals(ctyp) && x11_forwarding) &&
-	     !("auth-agent@openssh.com".equals(ctyp) && agent_forwarding)){
-            //System.err.println("Session.run: CHANNEL OPEN "+ctyp); 
-	    //throw new IOException("Session.run: CHANNEL OPEN "+ctyp);
-	    packet.reset();
-	    buf.putByte((byte)SSH_MSG_CHANNEL_OPEN_FAILURE);
-	    buf.putInt(buf.getInt());
- 	    buf.putInt(Channel.SSH_OPEN_ADMINISTRATIVELY_PROHIBITED);
-	    buf.putString(Util.empty);
-	    buf.putString(Util.empty);
-	    write(packet);
-	  }
-	  else{
-	    channel=Channel.getChannel(ctyp);
-	    addChannel(channel);
-	    channel.getData(buf);
-	    channel.init();
+					channel.setRecipient(1);
 
-	    Thread tmp=new Thread(channel);
-	    tmp.setName("Channel "+ctyp+" "+host);
-            if(daemon_thread){
-              tmp.setDaemon(daemon_thread);
-            }
-	    tmp.start();
-	    break;
-	  }
-	case SSH_MSG_CHANNEL_SUCCESS:
-          buf.getInt(); 
-	  buf.getShort(); 
-	  i=buf.getInt(); 
-	  channel=Channel.getChannel(i, this);
-	  if(channel==null){
-	    break;
-	  }
-	  channel.reply=1;
-	  break;
-	case SSH_MSG_CHANNEL_FAILURE:
-	  buf.getInt(); 
-	  buf.getShort(); 
-	  i=buf.getInt(); 
-	  channel=Channel.getChannel(i, this);
-	  if(channel==null){
-	    break;
-	  }
-	  channel.reply=0;
-	  break;
-	case SSH_MSG_GLOBAL_REQUEST:
-	  buf.getInt(); 
-	  buf.getShort(); 
-	  foo=buf.getString();       // request name
-	  reply=(buf.getByte()!=0);
-	  if(reply){
-	    packet.reset();
-	    buf.putByte((byte)SSH_MSG_REQUEST_FAILURE);
-	    write(packet);
-	  }
-	  break;
-	case SSH_MSG_REQUEST_FAILURE:
-	case SSH_MSG_REQUEST_SUCCESS:
-          Thread t=grr.getThread();
-          if(t!=null){
-            grr.setReply(msgType==SSH_MSG_REQUEST_SUCCESS? 1 : 0);
-            t.interrupt();
-          }
-	  break;
-	default:
-          //System.err.println("Session.run: unsupported type "+msgType); 
-	  throw new IOException("Unknown SSH message type "+msgType);
+					// -- [Begin] Fix synchronization bug --
+					synchronized (this) {
+						notify();
 	}
+					// -- [End] Fix synchronization bug --
       }
     }
-    catch(Exception e){
+		} catch (Exception e) {
       in_kex=false;
       if(JSch.getLogger().isEnabled(Logger.INFO)){
-        JSch.getLogger().log(Logger.INFO,
-                             "Caught an exception, leaving main loop due to " + e.getMessage());
+				JSch.getLogger().log(
+						Logger.INFO,
+						"Caught an exception, leaving main loop due to "
+								+ e.getMessage());
       }
       //System.err.println("# Session.run");
       //e.printStackTrace();
     }
     try{
       disconnect();
-    }
-    catch(NullPointerException e){
+		} catch (NullPointerException e) {
       //System.err.println("@1");
       //e.printStackTrace();
-    }
-    catch(Exception e){
+		} catch (Exception e) {
       //System.err.println("@2");
       //e.printStackTrace();
     }
@@ -1543,7 +1190,8 @@
   }
 
   public void disconnect(){
-    if(!isConnected) return;
+		if (!isConnected)
+			return;
     //System.err.println(this+": disconnect");
     //Thread.dumpStack();
     if(JSch.getLogger().isEnabled(Logger.INFO)){
@@ -1551,14 +1199,9 @@
                            "Disconnecting from "+host+" port "+port);
     }
     /*
-    for(int i=0; i<Channel.pool.size(); i++){
-      try{
-        Channel c=((Channel)(Channel.pool.elementAt(i)));
-	if(c.session==this) c.eof();
-      }
-      catch(Exception e){
-      }
-    } 
+		 * for(int i=0; i<Channel.pool.size(); i++){ try{ Channel
+		 * c=((Channel)(Channel.pool.elementAt(i))); if(c.session==this)
+		 * c.eof(); } catch(Exception e){ } }
     */
 
     Channel.disconnect(this);
@@ -1578,22 +1221,23 @@
     thread=null;
     try{
       if(io!=null){
-	if(io.in!=null) io.in.close();
-	if(io.out!=null) io.out.close();
-	if(io.out_ext!=null) io.out_ext.close();
+				if (io.in != null)
+					io.in.close();
+				if (io.out != null)
+					io.out.close();
+				if (io.out_ext != null)
+					io.out_ext.close();
       }
       if(proxy==null){
         if(socket!=null)
 	  socket.close();
-      }
-      else{
+			} else {
 	synchronized(proxy){
 	  proxy.close();	  
 	}
 	proxy=null;
       }
-    }
-    catch(Exception e){
+		} catch (Exception e) {
 //      e.printStackTrace();
     }
     io=null;
@@ -1607,14 +1251,20 @@
     //System.gc();
   }
 
-  public int setPortForwardingL(int lport, String host, int rport) throws JSchException{
+	public int setPortForwardingL(int lport, String host, int rport)
+			throws JSchException {
     return setPortForwardingL("127.0.0.1", lport, host, rport);
   }
-  public int setPortForwardingL(String boundaddress, int lport, String host, int rport) throws JSchException{
+
+	public int setPortForwardingL(String boundaddress, int lport, String host,
+			int rport) throws JSchException {
     return setPortForwardingL(boundaddress, lport, host, rport, null);
   }
-  public int setPortForwardingL(String boundaddress, int lport, String host, int rport, ServerSocketFactory ssf) throws JSchException{
-    PortWatcher pw=PortWatcher.addPort(this, boundaddress, lport, host, rport, ssf);
+
+	public int setPortForwardingL(String boundaddress, int lport, String host,
+			int rport, ServerSocketFactory ssf) throws JSchException {
+		PortWatcher pw = PortWatcher.addPort(this, boundaddress, lport, host,
+				rport, ssf);
     Thread tmp=new Thread(pw);
     tmp.setName("PortWatcher Thread for "+host);
     if(daemon_thread){
@@ -1623,37 +1273,55 @@
     tmp.start();
     return pw.lport;
   }
+
   public void delPortForwardingL(int lport) throws JSchException{
     delPortForwardingL("127.0.0.1", lport);
   }
-  public void delPortForwardingL(String boundaddress, int lport) throws JSchException{
+
+	public void delPortForwardingL(String boundaddress, int lport)
+			throws JSchException {
     PortWatcher.delPort(this, boundaddress, lport);
   }
+
   public String[] getPortForwardingL() throws JSchException{
     return PortWatcher.getPortForwarding(this);
   }
 
-  public void setPortForwardingR(int rport, String host, int lport) throws JSchException{
+	public void setPortForwardingR(int rport, String host, int lport)
+			throws JSchException {
     setPortForwardingR(null, rport, host, lport, (SocketFactory)null);
   }
-  public void setPortForwardingR(String bind_address, int rport, String host, int lport) throws JSchException{
-    setPortForwardingR(bind_address, rport, host, lport, (SocketFactory)null);
+
+	public void setPortForwardingR(String bind_address, int rport, String host,
+			int lport) throws JSchException {
+		setPortForwardingR(bind_address, rport, host, lport,
+				(SocketFactory) null);
   }
-  public void setPortForwardingR(int rport, String host, int lport, SocketFactory sf) throws JSchException{
+
+	public void setPortForwardingR(int rport, String host, int lport,
+			SocketFactory sf) throws JSchException {
     setPortForwardingR(null, rport, host, lport, sf);
   }
-  public void setPortForwardingR(String bind_address, int rport, String host, int lport, SocketFactory sf) throws JSchException{
-    ChannelForwardedTCPIP.addPort(this, bind_address, rport, host, lport, sf);
+
+	public void setPortForwardingR(String bind_address, int rport, String host,
+			int lport, SocketFactory sf) throws JSchException {
+		ChannelForwardedTCPIP.addPort(this, bind_address, rport, host, lport,
+				sf);
     setPortForwarding(bind_address, rport);
   }
 
-  public void setPortForwardingR(int rport, String daemon) throws JSchException{
+	public void setPortForwardingR(int rport, String daemon)
+			throws JSchException {
     setPortForwardingR(null, rport, daemon, null);
   }
-  public void setPortForwardingR(int rport, String daemon, Object[] arg) throws JSchException{
+
+	public void setPortForwardingR(int rport, String daemon, Object[] arg)
+			throws JSchException {
     setPortForwardingR(null, rport, daemon, arg);
   }
-  public void setPortForwardingR(String bind_address, int rport, String daemon, Object[] arg) throws JSchException{
+
+	public void setPortForwardingR(String bind_address, int rport,
+			String daemon, Object[] arg) throws JSchException {
     ChannelForwardedTCPIP.addPort(this, bind_address, rport, daemon, arg);
     setPortForwarding(bind_address, rport);
   }
@@ -1661,21 +1329,35 @@
   private class GlobalRequestReply{
     private Thread thread=null;
     private int reply=-1;
+
     void setThread(Thread thread){
       this.thread=thread;
       this.reply=-1;
     }
-    Thread getThread(){ return thread; }
-    void setReply(int reply){ this.reply=reply; }
-    int getReply(){ return this.reply; }
+
+		Thread getThread() {
+			return thread;
+		}
+
+		void setReply(int reply) {
+			this.reply = reply;
   }
+
+		int getReply() {
+			return this.reply;
+		}
+	}
+
   private GlobalRequestReply grr=new GlobalRequestReply();
-  private void setPortForwarding(String bind_address, int rport) throws JSchException{
+
+	private void setPortForwarding(String bind_address, int rport)
+			throws JSchException {
     synchronized(grr){
     Buffer buf=new Buffer(100); // ??
     Packet packet=new Packet(buf);
 
-    String address_to_bind=ChannelForwardedTCPIP.normalize(bind_address);
+			String address_to_bind = ChannelForwardedTCPIP
+					.normalize(bind_address);
 
     grr.setThread(Thread.currentThread());
 
@@ -1692,8 +1374,7 @@
       buf.putString(Util.str2byte(address_to_bind));
       buf.putInt(rport);
       write(packet);
-    }
-    catch(Exception e){
+			} catch (Exception e) {
       grr.setThread(null);
       if(e instanceof Throwable)
         throw new JSchException(e.toString(), (Throwable)e);
@@ -1703,18 +1384,22 @@
     int count = 0;
     int reply = grr.getReply();
     while(count < 10 && reply == -1){
-      try{ Thread.sleep(1000); }
-      catch(Exception e){
+				try {
+					Thread.sleep(1000);
+				} catch (Exception e) {
       }
       count++; 
       reply = grr.getReply();
     }
     grr.setThread(null);
     if(reply != 1){
-      throw new JSchException("remote port forwarding failed for listen port "+rport);
+				throw new JSchException(
+						"remote port forwarding failed for listen port "
+								+ rport);
     }
     }
   }
+
   public void delPortForwardingR(int rport) throws JSchException{
     ChannelForwardedTCPIP.delPort(this, rport);
   }
@@ -1726,23 +1411,26 @@
     }
     String foo=getConfig(method);
     if(foo!=null){
-      if(method.equals("zlib") ||
-         (isAuthed && method.equals("zlib@openssh.com"))){
+			if (method.equals("zlib")
+					|| (isAuthed && method.equals("zlib@openssh.com"))) {
         try{
           Class c=Class.forName(foo);
           deflater=(Compression)(c.newInstance());
           int level=6;
-          try{ level=Integer.parseInt(getConfig("compression_level"));}
-          catch(Exception ee){ }
-          deflater.init(Compression.DEFLATER, level);
+					try {
+						level = Integer
+								.parseInt(getConfig("compression_level"));
+					} catch (Exception ee) {
         }
-        catch(Exception ee){
+					deflater.init(Compression.DEFLATER, level);
+				} catch (Exception ee) {
           throw new JSchException(ee.toString(), ee);
           //System.err.println(foo+" isn't accessible.");
         }
       }
     }
   }
+
   private void initInflater(String method) throws JSchException{
     if(method.equals("none")){
       inflater=null;
@@ -1750,14 +1438,13 @@
     }
     String foo=getConfig(method);
     if(foo!=null){
-      if(method.equals("zlib") ||
-         (isAuthed && method.equals("zlib@openssh.com"))){
+			if (method.equals("zlib")
+					|| (isAuthed && method.equals("zlib@openssh.com"))) {
         try{
           Class c=Class.forName(foo);
           inflater=(Compression)(c.newInstance());
           inflater.init(Compression.INFLATER, 0);
-        }
-        catch(Exception ee){
+				} catch (Exception ee) {
           throw new JSchException(ee.toString(), ee);
 	    //System.err.println(foo+" isn't accessible.");
         }
@@ -1769,21 +1456,55 @@
     channel.setSession(this);
   }
 
-  public void setProxy(Proxy proxy){ this.proxy=proxy; }
-  public void setHost(String host){ this.host=host; }
-  public void setPort(int port){ this.port=port; }
-  void setUserName(String username){ this.username=username; }
-  public void setUserInfo(UserInfo userinfo){ this.userinfo=userinfo; }
-  public UserInfo getUserInfo(){ return userinfo; }
-  public void setInputStream(InputStream in){ this.in=in; }
-  public void setOutputStream(OutputStream out){ this.out=out; }
-  public void setX11Host(String host){ ChannelX11.setHost(host); }
-  public void setX11Port(int port){ ChannelX11.setPort(port); }
-  public void setX11Cookie(String cookie){ ChannelX11.setCookie(cookie); }
+	public void setProxy(Proxy proxy) {
+		this.proxy = proxy;
+	}
+
+	public void setHost(String host) {
+		this.host = host;
+	}
+
+	public void setPort(int port) {
+		this.port = port;
+	}
+
+	void setUserName(String username) {
+		this.username = username;
+	}
+
+	public void setUserInfo(UserInfo userinfo) {
+		this.userinfo = userinfo;
+	}
+
+	public UserInfo getUserInfo() {
+		return userinfo;
+	}
+
+	public void setInputStream(InputStream in) {
+		this.in = in;
+	}
+
+	public void setOutputStream(OutputStream out) {
+		this.out = out;
+	}
+
+	public void setX11Host(String host) {
+		ChannelX11.setHost(host);
+	}
+
+	public void setX11Port(int port) {
+		ChannelX11.setPort(port);
+	}
+
+	public void setX11Cookie(String cookie) {
+		ChannelX11.setCookie(cookie);
+	}
+
   public void setPassword(String password){
     if(password!=null)
       this.password=Util.str2byte(password);
   }
+
   public void setPassword(byte[] password){ 
     if(password!=null){
       this.password=new byte[password.length];
@@ -1819,18 +1540,27 @@
     Object foo=null;
     if(config!=null){
       foo=config.get(key);
-      if(foo instanceof String) return (String)foo;
+			if (foo instanceof String)
+				return (String) foo;
     }
     foo=jsch.getConfig(key);
-    if(foo instanceof String) return (String)foo;
+		if (foo instanceof String)
+			return (String) foo;
     return null;
   }
 
   public void setSocketFactory(SocketFactory sfactory){ 
     socket_factory=sfactory;
   }
-  public boolean isConnected(){ return isConnected; }
-  public int getTimeout(){ return timeout; }
+
+	public boolean isConnected() {
+		return isConnected;
+	}
+
+	public int getTimeout() {
+		return timeout;
+	}
+
   public void setTimeout(int timeout) throws JSchException {
     if(socket==null){
       if(timeout<0){
@@ -1842,19 +1572,21 @@
     try{
       socket.setSoTimeout(timeout);
       this.timeout=timeout;
-    }
-    catch(Exception e){
+		} catch (Exception e) {
       if(e instanceof Throwable)
         throw new JSchException(e.toString(), (Throwable)e);
       throw new JSchException(e.toString());
     }
   }
+
   public String getServerVersion(){
     return Util.byte2str(V_S);
   }
+
   public String getClientVersion(){
     return Util.byte2str(V_C);
   }
+
   public void setClientVersion(String cv){
     V_C=Util.str2byte(cv);
   }
@@ -1867,7 +1599,9 @@
     write(packet);
   }
 
-  private static final byte[] keepalivemsg=Util.str2byte("keepalive@jcraft.com");
+	private static final byte[] keepalivemsg = Util
+			.str2byte("keepalive@jcraft.com");
+
   public void sendKeepAliveMsg() throws Exception{
     Buffer buf=new Buffer();
     Packet packet=new Packet(buf);
@@ -1879,13 +1613,27 @@
   }
   
   private HostKey hostkey=null;
-  public HostKey getHostKey(){ return hostkey; }
-  public String getHost(){return host;}
-  public String getUserName(){return username;}
-  public int getPort(){return port;}
+
+	public HostKey getHostKey() {
+		return hostkey;
+	}
+
+	public String getHost() {
+		return host;
+	}
+
+	public String getUserName() {
+		return username;
+	}
+
+	public int getPort() {
+		return port;
+	}
+
   public void setHostKeyAlias(String hostKeyAlias){
     this.hostKeyAlias=hostKeyAlias;
   }
+
   public String getHostKeyAlias(){
     return hostKeyAlias;
   }
@@ -1894,6 +1642,7 @@
     setTimeout(interval);
     this.serverAliveInterval=interval;
   }
+
   public void setServerAliveCountMax(int count){
     this.serverAliveCountMax=count;
   }
@@ -1901,6 +1650,7 @@
   public int getServerAliveInterval(){
     return this.serverAliveInterval;
   }
+
   public int getServerAliveCountMax(){
     return this.serverAliveCountMax;
   }
@@ -1909,13 +1659,16 @@
     this.daemon_thread=enable;
   }
 
+	public OutputStream getOutputStream() throws IOException {
+		return socket.getOutputStream();
+	}
+
   private String[] checkCiphers(String ciphers){
     if(ciphers==null || ciphers.length()==0)
       return null;
 
     if(JSch.getLogger().isEnabled(Logger.INFO)){
-      JSch.getLogger().log(Logger.INFO, 
-                           "CheckCiphers: "+ciphers);
+			JSch.getLogger().log(Logger.INFO, "CheckCiphers: " + ciphers);
     }
 
     java.util.Vector result=new java.util.Vector();
@@ -1932,8 +1685,8 @@
 
     if(JSch.getLogger().isEnabled(Logger.INFO)){
       for(int i=0; i<foo.length; i++){
-        JSch.getLogger().log(Logger.INFO, 
-                             foo[i]+" is not available.");
+				JSch.getLogger()
+						.log(Logger.INFO, foo[i] + " is not available.");
       }
     }
 
@@ -1944,13 +1697,12 @@
     try{
       Class c=Class.forName(cipher);
       Cipher _c=(Cipher)(c.newInstance());
-      _c.init(Cipher.ENCRYPT_MODE,
-              new byte[_c.getBlockSize()],
+			_c.init(Cipher.ENCRYPT_MODE, new byte[_c.getBlockSize()],
               new byte[_c.getIVSize()]);
       return true;
-    }
-    catch(Exception e){
+		} catch (Exception e) {
       return false;
     }
   }
+	
 }
diff -urw jsch-0.1.44-clean//src/com/jcraft/jsch/Util.java jsch-0.1.44/src/com/jcraft/jsch/Util.java
--- jsch-0.1.44-clean//src/com/jcraft/jsch/Util.java	2010-10-19 17:25:56.000000000 +0900
+++ jsch-0.1.44/src/com/jcraft/jsch/Util.java	2011-03-23 16:30:13.601618001 +0900
@@ -29,6 +29,7 @@
 
 package com.jcraft.jsch;
 import java.net.Socket;
+import java.util.StringTokenizer;
 
 class Util{
 
@@ -101,20 +102,28 @@
   static String[] split(String foo, String split){
     if(foo==null)
       return null;
-    byte[] buf=Util.str2byte(foo);
+
+//    byte[] buf=Util.str2byte(foo);
     java.util.Vector bar=new java.util.Vector();
-    int start=0;
-    int index;
-    while(true){
-      index=foo.indexOf(split, start);
-      if(index>=0){
-	bar.addElement(Util.byte2str(buf, start, index-start));
-	start=index+1;
-	continue;
-      }
-      bar.addElement(Util.byte2str(buf, start, buf.length-start));
-      break;
+//    int start=0;
+//    int index;
+//    while(true){
+//			index = foo.indexOf(split, start);
+//			if (index >= 0) {
+//				bar.addElement(Util.byte2str(buf, start, index - start));
+//				start = index + 1;
+//				continue;
+//			}
+//      bar.addElement(Util.byte2str(buf, start, buf.length-start));
+//      break;
+//    }
+    
+    StringTokenizer tokenizer = new StringTokenizer(foo, split);
+    while (tokenizer.hasMoreTokens()) {
+    	String s = tokenizer.nextToken();
+    	bar.addElement(s);
     }
+    
     String[] result=new String[bar.size()];
     for(int i=0; i<result.length; i++){
       result[i]=(String)(bar.elementAt(i));
@@ -391,10 +400,10 @@
   static byte[] str2byte(String str, String encoding){
     if(str==null) 
       return null;
-    try{ return str.getBytes(encoding); }
-    catch(java.io.UnsupportedEncodingException e){
+//    try{ return str.getBytes(encoding); }
+//    catch(java.io.UnsupportedEncodingException e){
       return str.getBytes();
-    }
+//    }
   }
 
   static byte[] str2byte(String str){
@@ -406,10 +415,10 @@
   }
 
   static String byte2str(byte[] str, int s, int l, String encoding){
-    try{ return new String(str, s, l, encoding); }
-    catch(java.io.UnsupportedEncodingException e){
+//    try{ return new String(str, s, l, encoding); }
+//    catch(java.io.UnsupportedEncodingException e){
       return new String(str, s, l);
-    }
+//    }
   }
 
   static String byte2str(byte[] str){
Only in jsch-0.1.44: tmp
Only in jsch-0.1.44: values.bin
